var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
import { ref, getCurrentInstance, inject, computed, provide, unref, isRef, defineComponent, watch, resolveComponent, openBlock, createBlock, mergeProps, onMounted, onUpdated, withCtx, createElementVNode, toDisplayString, nextTick, createElementBlock, Fragment, renderList, createVNode, withDirectives, createTextVNode, createCommentVNode, vShow, renderSlot, resolveDynamicComponent, normalizeClass, withModifiers, h, vModelText, normalizeStyle, Transition, useSlots, normalizeProps, guardReactiveProps, resolveDirective, isVNode, Comment } from "vue";
const COMPONENTS_SIZE = ["", "default", "small", "large"];
const validateSize = (val) => ["", ...COMPONENTS_SIZE].includes(val);
const globalConfig = ref();
const globalConfigKey = Symbol("GlobalConfigKey");
function useGlobalConfig(key, defaultValue = void 0) {
  const config = getCurrentInstance() ? inject(globalConfigKey, globalConfig) : globalConfig;
  if (key) {
    return computed(() => {
      var _a2, _b;
      return (_b = (_a2 = config.value) == null ? void 0 : _a2[key]) != null ? _b : defaultValue;
    });
  } else {
    return config;
  }
}
const provideGlobalConfig = (config, app) => {
  var _a2;
  const inSetup = !!getCurrentInstance();
  const provideFn = (_a2 = app == null ? void 0 : app.provide) != null ? _a2 : inSetup ? provide : void 0;
  const context = computed(() => {
    return unref(config);
  });
  provideFn == null ? void 0 : provideFn(globalConfigKey, context);
  if (!globalConfig.value) {
    globalConfig.value = context.value;
  }
  return context;
};
var freeGlobal = typeof global == "object" && global && global.Object === Object && global;
var freeGlobal$1 = freeGlobal;
var freeSelf = typeof self == "object" && self && self.Object === Object && self;
var root = freeGlobal$1 || freeSelf || Function("return this")();
var root$1 = root;
var Symbol$1 = root$1.Symbol;
var Symbol$2 = Symbol$1;
var objectProto$4 = Object.prototype;
var hasOwnProperty$3 = objectProto$4.hasOwnProperty;
var nativeObjectToString$1 = objectProto$4.toString;
var symToStringTag$1 = Symbol$2 ? Symbol$2.toStringTag : void 0;
function getRawTag(value) {
  var isOwn = hasOwnProperty$3.call(value, symToStringTag$1), tag = value[symToStringTag$1];
  try {
    value[symToStringTag$1] = void 0;
    var unmasked = true;
  } catch (e) {
  }
  var result = nativeObjectToString$1.call(value);
  if (unmasked) {
    if (isOwn) {
      value[symToStringTag$1] = tag;
    } else {
      delete value[symToStringTag$1];
    }
  }
  return result;
}
var objectProto$3 = Object.prototype;
var nativeObjectToString = objectProto$3.toString;
function objectToString(value) {
  return nativeObjectToString.call(value);
}
var nullTag = "[object Null]", undefinedTag = "[object Undefined]";
var symToStringTag = Symbol$2 ? Symbol$2.toStringTag : void 0;
function baseGetTag(value) {
  if (value == null) {
    return value === void 0 ? undefinedTag : nullTag;
  }
  return symToStringTag && symToStringTag in Object(value) ? getRawTag(value) : objectToString(value);
}
function isObjectLike(value) {
  return value != null && typeof value == "object";
}
var symbolTag = "[object Symbol]";
function isSymbol(value) {
  return typeof value == "symbol" || isObjectLike(value) && baseGetTag(value) == symbolTag;
}
function arrayMap(array, iteratee) {
  var index = -1, length = array == null ? 0 : array.length, result = Array(length);
  while (++index < length) {
    result[index] = iteratee(array[index], index, array);
  }
  return result;
}
var isArray$1 = Array.isArray;
var isArray$2 = isArray$1;
var INFINITY$1 = 1 / 0;
var symbolProto = Symbol$2 ? Symbol$2.prototype : void 0, symbolToString = symbolProto ? symbolProto.toString : void 0;
function baseToString(value) {
  if (typeof value == "string") {
    return value;
  }
  if (isArray$2(value)) {
    return arrayMap(value, baseToString) + "";
  }
  if (isSymbol(value)) {
    return symbolToString ? symbolToString.call(value) : "";
  }
  var result = value + "";
  return result == "0" && 1 / value == -INFINITY$1 ? "-0" : result;
}
function isObject(value) {
  var type = typeof value;
  return value != null && (type == "object" || type == "function");
}
var asyncTag = "[object AsyncFunction]", funcTag = "[object Function]", genTag = "[object GeneratorFunction]", proxyTag = "[object Proxy]";
function isFunction(value) {
  if (!isObject(value)) {
    return false;
  }
  var tag = baseGetTag(value);
  return tag == funcTag || tag == genTag || tag == asyncTag || tag == proxyTag;
}
var coreJsData = root$1["__core-js_shared__"];
var coreJsData$1 = coreJsData;
var maskSrcKey = function() {
  var uid = /[^.]+$/.exec(coreJsData$1 && coreJsData$1.keys && coreJsData$1.keys.IE_PROTO || "");
  return uid ? "Symbol(src)_1." + uid : "";
}();
function isMasked(func) {
  return !!maskSrcKey && maskSrcKey in func;
}
var funcProto$1 = Function.prototype;
var funcToString$1 = funcProto$1.toString;
function toSource(func) {
  if (func != null) {
    try {
      return funcToString$1.call(func);
    } catch (e) {
    }
    try {
      return func + "";
    } catch (e) {
    }
  }
  return "";
}
var reRegExpChar = /[\\^$.*+?()[\]{}|]/g;
var reIsHostCtor = /^\[object .+?Constructor\]$/;
var funcProto = Function.prototype, objectProto$2 = Object.prototype;
var funcToString = funcProto.toString;
var hasOwnProperty$2 = objectProto$2.hasOwnProperty;
var reIsNative = RegExp("^" + funcToString.call(hasOwnProperty$2).replace(reRegExpChar, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$");
function baseIsNative(value) {
  if (!isObject(value) || isMasked(value)) {
    return false;
  }
  var pattern = isFunction(value) ? reIsNative : reIsHostCtor;
  return pattern.test(toSource(value));
}
function getValue(object, key) {
  return object == null ? void 0 : object[key];
}
function getNative(object, key) {
  var value = getValue(object, key);
  return baseIsNative(value) ? value : void 0;
}
function eq(value, other) {
  return value === other || value !== value && other !== other;
}
var reIsDeepProp = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/, reIsPlainProp = /^\w*$/;
function isKey(value, object) {
  if (isArray$2(value)) {
    return false;
  }
  var type = typeof value;
  if (type == "number" || type == "symbol" || type == "boolean" || value == null || isSymbol(value)) {
    return true;
  }
  return reIsPlainProp.test(value) || !reIsDeepProp.test(value) || object != null && value in Object(object);
}
var nativeCreate = getNative(Object, "create");
var nativeCreate$1 = nativeCreate;
function hashClear() {
  this.__data__ = nativeCreate$1 ? nativeCreate$1(null) : {};
  this.size = 0;
}
function hashDelete(key) {
  var result = this.has(key) && delete this.__data__[key];
  this.size -= result ? 1 : 0;
  return result;
}
var HASH_UNDEFINED$1 = "__lodash_hash_undefined__";
var objectProto$1 = Object.prototype;
var hasOwnProperty$1 = objectProto$1.hasOwnProperty;
function hashGet(key) {
  var data = this.__data__;
  if (nativeCreate$1) {
    var result = data[key];
    return result === HASH_UNDEFINED$1 ? void 0 : result;
  }
  return hasOwnProperty$1.call(data, key) ? data[key] : void 0;
}
var objectProto = Object.prototype;
var hasOwnProperty = objectProto.hasOwnProperty;
function hashHas(key) {
  var data = this.__data__;
  return nativeCreate$1 ? data[key] !== void 0 : hasOwnProperty.call(data, key);
}
var HASH_UNDEFINED = "__lodash_hash_undefined__";
function hashSet(key, value) {
  var data = this.__data__;
  this.size += this.has(key) ? 0 : 1;
  data[key] = nativeCreate$1 && value === void 0 ? HASH_UNDEFINED : value;
  return this;
}
function Hash(entries) {
  var index = -1, length = entries == null ? 0 : entries.length;
  this.clear();
  while (++index < length) {
    var entry = entries[index];
    this.set(entry[0], entry[1]);
  }
}
Hash.prototype.clear = hashClear;
Hash.prototype["delete"] = hashDelete;
Hash.prototype.get = hashGet;
Hash.prototype.has = hashHas;
Hash.prototype.set = hashSet;
function listCacheClear() {
  this.__data__ = [];
  this.size = 0;
}
function assocIndexOf(array, key) {
  var length = array.length;
  while (length--) {
    if (eq(array[length][0], key)) {
      return length;
    }
  }
  return -1;
}
var arrayProto = Array.prototype;
var splice = arrayProto.splice;
function listCacheDelete(key) {
  var data = this.__data__, index = assocIndexOf(data, key);
  if (index < 0) {
    return false;
  }
  var lastIndex = data.length - 1;
  if (index == lastIndex) {
    data.pop();
  } else {
    splice.call(data, index, 1);
  }
  --this.size;
  return true;
}
function listCacheGet(key) {
  var data = this.__data__, index = assocIndexOf(data, key);
  return index < 0 ? void 0 : data[index][1];
}
function listCacheHas(key) {
  return assocIndexOf(this.__data__, key) > -1;
}
function listCacheSet(key, value) {
  var data = this.__data__, index = assocIndexOf(data, key);
  if (index < 0) {
    ++this.size;
    data.push([key, value]);
  } else {
    data[index][1] = value;
  }
  return this;
}
function ListCache(entries) {
  var index = -1, length = entries == null ? 0 : entries.length;
  this.clear();
  while (++index < length) {
    var entry = entries[index];
    this.set(entry[0], entry[1]);
  }
}
ListCache.prototype.clear = listCacheClear;
ListCache.prototype["delete"] = listCacheDelete;
ListCache.prototype.get = listCacheGet;
ListCache.prototype.has = listCacheHas;
ListCache.prototype.set = listCacheSet;
var Map$1 = getNative(root$1, "Map");
var Map$2 = Map$1;
function mapCacheClear() {
  this.size = 0;
  this.__data__ = {
    "hash": new Hash(),
    "map": new (Map$2 || ListCache)(),
    "string": new Hash()
  };
}
function isKeyable(value) {
  var type = typeof value;
  return type == "string" || type == "number" || type == "symbol" || type == "boolean" ? value !== "__proto__" : value === null;
}
function getMapData(map, key) {
  var data = map.__data__;
  return isKeyable(key) ? data[typeof key == "string" ? "string" : "hash"] : data.map;
}
function mapCacheDelete(key) {
  var result = getMapData(this, key)["delete"](key);
  this.size -= result ? 1 : 0;
  return result;
}
function mapCacheGet(key) {
  return getMapData(this, key).get(key);
}
function mapCacheHas(key) {
  return getMapData(this, key).has(key);
}
function mapCacheSet(key, value) {
  var data = getMapData(this, key), size = data.size;
  data.set(key, value);
  this.size += data.size == size ? 0 : 1;
  return this;
}
function MapCache(entries) {
  var index = -1, length = entries == null ? 0 : entries.length;
  this.clear();
  while (++index < length) {
    var entry = entries[index];
    this.set(entry[0], entry[1]);
  }
}
MapCache.prototype.clear = mapCacheClear;
MapCache.prototype["delete"] = mapCacheDelete;
MapCache.prototype.get = mapCacheGet;
MapCache.prototype.has = mapCacheHas;
MapCache.prototype.set = mapCacheSet;
var FUNC_ERROR_TEXT = "Expected a function";
function memoize(func, resolver) {
  if (typeof func != "function" || resolver != null && typeof resolver != "function") {
    throw new TypeError(FUNC_ERROR_TEXT);
  }
  var memoized = function() {
    var args = arguments, key = resolver ? resolver.apply(this, args) : args[0], cache = memoized.cache;
    if (cache.has(key)) {
      return cache.get(key);
    }
    var result = func.apply(this, args);
    memoized.cache = cache.set(key, result) || cache;
    return result;
  };
  memoized.cache = new (memoize.Cache || MapCache)();
  return memoized;
}
memoize.Cache = MapCache;
var MAX_MEMOIZE_SIZE = 500;
function memoizeCapped(func) {
  var result = memoize(func, function(key) {
    if (cache.size === MAX_MEMOIZE_SIZE) {
      cache.clear();
    }
    return key;
  });
  var cache = result.cache;
  return result;
}
var rePropName = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g;
var reEscapeChar = /\\(\\)?/g;
var stringToPath = memoizeCapped(function(string) {
  var result = [];
  if (string.charCodeAt(0) === 46) {
    result.push("");
  }
  string.replace(rePropName, function(match, number, quote, subString) {
    result.push(quote ? subString.replace(reEscapeChar, "$1") : number || match);
  });
  return result;
});
var stringToPath$1 = stringToPath;
function toString(value) {
  return value == null ? "" : baseToString(value);
}
function castPath(value, object) {
  if (isArray$2(value)) {
    return value;
  }
  return isKey(value, object) ? [value] : stringToPath$1(toString(value));
}
var INFINITY = 1 / 0;
function toKey(value) {
  if (typeof value == "string" || isSymbol(value)) {
    return value;
  }
  var result = value + "";
  return result == "0" && 1 / value == -INFINITY ? "-0" : result;
}
function baseGet(object, path) {
  path = castPath(path, object);
  var index = 0, length = path.length;
  while (object != null && index < length) {
    object = object[toKey(path[index++])];
  }
  return index && index == length ? object : void 0;
}
function get(object, path, defaultValue) {
  var result = object == null ? void 0 : baseGet(object, path);
  return result === void 0 ? defaultValue : result;
}
var Chinese = {
  name: "zh-cn",
  fu: {
    filter_bar: {
      filter: "\u7B5B\u9009",
      results: "\u4E2A\u7ED3\u679C",
      clear: "\u6E05\u7A7A\u6761\u4EF6",
      drawer_title: "\u7B5B\u9009\u6761\u4EF6",
      cancel: "\u53D6\u6D88",
      search: "\u67E5\u8BE2",
      select_all: "\u5168\u9009",
      more: "\u66F4\u591A"
    },
    search_bar: {
      search: "\u641C\u7D22",
      adv_search: "\u9AD8\u7EA7\u641C\u7D22",
      ok: "\u786E\u5B9A",
      cancel: "\u53D6\u6D88",
      please_select: "\u8BF7\u9009\u62E9",
      please_input: "\u8BF7\u8F93\u5165",
      like: "\u5305\u542B",
      not_like: "\u4E0D\u5305\u542B",
      in: "\u5C5E\u4E8E",
      not_in: "\u4E0D\u5C5E\u4E8E",
      gt: "\u5927\u4E8E",
      ge: "\u5927\u4E8E\u7B49\u4E8E",
      lt: "\u5C0F\u4E8E",
      le: "\u5C0F\u4E8E\u7B49\u4E8E",
      eq: "\u7B49\u4E8E",
      ne: "\u4E0D\u7B49\u4E8E",
      between: "\u4E4B\u95F4",
      select_date: "\u9009\u62E9\u65E5\u671F",
      start_date: "\u5F00\u59CB\u65E5\u671F",
      end_date: "\u7ED3\u675F\u65E5\u671F",
      select_date_time: "\u9009\u62E9\u65E5\u671F\u65F6\u95F4",
      start_date_time: "\u5F00\u59CB\u65E5\u671F\u65F6\u95F4",
      end_date_time: "\u7ED3\u675F\u65E5\u671F\u65F6\u95F4",
      range_separator: "\u81F3",
      data_time_error: "\u5F00\u59CB\u65E5\u671F\u4E0D\u80FD\u5927\u4E8E\u7ED3\u675F\u65E5\u671F",
      clean: "\u6E05\u7A7A",
      refresh: "\u5237\u65B0"
    },
    table: {
      ok: "\u786E\u5B9A",
      reset: "\u91CD\u7F6E",
      custom_table_fields: "\u81EA\u5B9A\u4E49\u8868\u683C\u5B57\u6BB5",
      custom_table_fields_desc: "\u56FA\u5B9A\u5B57\u6BB5\u4E0D\u5728\u9009\u62E9\u8303\u56F4\uFF0C\u53EF\u62D6\u62FD\u81EA\u5B9A\u4E49\u987A\u5E8F",
      custom_table_rows: "\u9009\u9879\u5217",
      more: "\u66F4\u591A"
    },
    steps: {
      cancel: "\u53D6\u6D88",
      next: "\u4E0B\u4E00\u6B65",
      prev: "\u4E0A\u4E00\u6B65",
      finish: "\u5B8C\u6210"
    }
  }
};
const buildTranslator = (locale) => (path, option) => translate(path, option, unref(locale));
const translate = (path, option, locale) => get(locale, path, path).replace(/\{(\w+)\}/g, (_, key) => {
  var _a2;
  return `${(_a2 = option == null ? void 0 : option[key]) != null ? _a2 : `{${key}}`}`;
});
const buildLocaleContext = (locale) => {
  const lang = computed(() => unref(locale).name);
  const localeRef = isRef(locale) ? locale : ref(locale);
  return {
    lang,
    locale: localeRef,
    t: buildTranslator(locale)
  };
};
const useLocale = () => {
  const locale = useGlobalConfig("locale");
  return buildLocaleContext(computed(() => locale.value || Chinese));
};
const useProp = (name2) => {
  const vm = getCurrentInstance();
  return computed(() => {
    var _a2, _b;
    return (_b = ((_a2 = vm.proxy) == null ? void 0 : _a2.$props)[name2]) != null ? _b : void 0;
  });
};
const useSize = (fallback, ignore = {}) => {
  const emptyRef = ref(void 0);
  const size = ignore.prop ? emptyRef : useProp("size");
  const globalConfig2 = ignore.global ? emptyRef : useGlobalConfig("size");
  return computed(() => size.value || unref(fallback) || globalConfig2.value || "");
};
const useSizeProp = {
  type: String,
  validator: validateSize
};
var _export_sfc = (sfc, props) => {
  const target = sfc.__vccOpts || sfc;
  for (const [key, val] of props) {
    target[key] = val;
  }
  return target;
};
const __default__$u = { name: "FuFilterInput" };
const _sfc_main$J = /* @__PURE__ */ defineComponent(__spreadProps(__spreadValues({}, __default__$u), {
  props: {
    size: {
      type: String,
      validator: validateSize
    },
    modelValue: String
  },
  emits: ["update:modelValue", "change"],
  setup(__props, { emit }) {
    const props = __props;
    const quick = ref("");
    const configSize = useSize();
    watch(() => props.modelValue, (val) => {
      quick.value = val;
    });
    function input(e) {
      emit("update:modelValue", quick.value, e);
    }
    function blur(e) {
      emit("change", quick.value, e);
    }
    function clear() {
      emit("update:modelValue", quick.value);
      emit("change", quick.value);
    }
    function keydown(e) {
      const event = e;
      if (event.key === "Enter") {
        emit("change", quick.value, e);
      }
    }
    return (_ctx, _cache) => {
      const _component_el_input = resolveComponent("el-input");
      return openBlock(), createBlock(_component_el_input, mergeProps({
        class: "fu-filter-input",
        "prefix-icon": "Search",
        modelValue: quick.value,
        "onUpdate:modelValue": _cache[0] || (_cache[0] = ($event) => quick.value = $event),
        onInput: input,
        onBlur: blur,
        onKeydown: keydown,
        onClear: clear
      }, _ctx.$attrs, {
        clearable: "",
        size: unref(configSize)
      }), null, 16, ["modelValue", "size"]);
    };
  }
}));
var FuFilterInput = /* @__PURE__ */ _export_sfc(_sfc_main$J, [["__file", "/Users/runner/work/fit2cloud-ui-plus/fit2cloud-ui-plus/src/components/filter-bar/FuFilterInput.vue"]]);
const _sfc_main$I = /* @__PURE__ */ defineComponent({
  __name: "FuFilterConditionText",
  props: {
    condition: {
      type: Object,
      required: true
    }
  },
  setup(__props) {
    const props = __props;
    const textRef = ref(null);
    const disabled = ref(true);
    const text = computed(() => {
      let condition = props.condition;
      return condition.label + " " + condition.valueLabel || condition.value;
    });
    function computeDisable() {
      nextTick(() => {
        const el = textRef.value;
        disabled.value = el === null || el.getBoundingClientRect().width < 320;
      });
    }
    onMounted(() => computeDisable());
    onUpdated(() => computeDisable());
    return (_ctx, _cache) => {
      const _component_el_tooltip = resolveComponent("el-tooltip");
      return openBlock(), createBlock(_component_el_tooltip, {
        content: unref(text),
        placement: "top",
        disabled: disabled.value
      }, {
        default: withCtx(() => [
          createElementVNode("div", {
            class: "condition-text",
            ref_key: "textRef",
            ref: textRef
          }, toDisplayString(unref(text)), 513)
        ]),
        _: 1
      }, 8, ["content", "disabled"]);
    };
  }
});
var FuFilterConditionText = /* @__PURE__ */ _export_sfc(_sfc_main$I, [["__file", "/Users/runner/work/fit2cloud-ui-plus/fit2cloud-ui-plus/src/components/filter-bar/FuFilterConditionText.vue"]]);
const _hoisted_1$o = { class: "fu-filter-conditions" };
const _sfc_main$H = /* @__PURE__ */ defineComponent({
  __name: "FuFilterConditions",
  props: {
    conditions: Array
  },
  emits: ["change"],
  setup(__props, { emit }) {
    const props = __props;
    function remove(index) {
      var _a2;
      (_a2 = props.conditions) == null ? void 0 : _a2.splice(index, 1);
      emit("change", props.conditions);
    }
    return (_ctx, _cache) => {
      const _component_CloseBold = resolveComponent("CloseBold");
      const _component_el_icon = resolveComponent("el-icon");
      return openBlock(), createElementBlock("div", _hoisted_1$o, [
        (openBlock(true), createElementBlock(Fragment, null, renderList(__props.conditions, (condition, index) => {
          return openBlock(), createElementBlock("div", {
            class: "fu-filter-conditions__item",
            key: index
          }, [
            createVNode(FuFilterConditionText, { condition }, null, 8, ["condition"]),
            createVNode(_component_el_icon, {
              class: "fu-scale-click",
              onClick: ($event) => remove(index)
            }, {
              default: withCtx(() => [
                createVNode(_component_CloseBold)
              ]),
              _: 2
            }, 1032, ["onClick"])
          ]);
        }), 128))
      ]);
    };
  }
});
var FuFilterConditions = /* @__PURE__ */ _export_sfc(_sfc_main$H, [["__file", "/Users/runner/work/fit2cloud-ui-plus/fit2cloud-ui-plus/src/components/filter-bar/FuFilterConditions.vue"]]);
const selectKey = Symbol("SelectKey");
const referenceKey$1 = Symbol("ReferenceKey");
const _hoisted_1$n = { class: "fu-filter__result" };
const _hoisted_2$f = { style: { "opacity": "0.6" } };
const _hoisted_3$d = /* @__PURE__ */ createElementVNode("div", { class: "fu-filter__split" }, null, -1);
const _hoisted_4$2 = { class: "drawer-body" };
const _hoisted_5$1 = { class: "drawer-footer" };
const __default__$t = { name: "FuFilter" };
const _sfc_main$G = /* @__PURE__ */ defineComponent(__spreadProps(__spreadValues({}, __default__$t), {
  props: {
    size: {
      type: String,
      validator: validateSize,
      required: true
    },
    count: {
      type: Number,
      default: 0
    },
    components: Array,
    drawerWidth: {
      type: [Number, String],
      default: "680px"
    },
    showEmpty: Boolean
  },
  emits: ["filter"],
  setup(__props, { expose, emit }) {
    const props = __props;
    const { t: t2 } = useLocale();
    const filterRef = ref(null);
    const conditionsRef = ref(null);
    const configSize = useSize();
    const drawer = ref(true);
    const scroll = ref(false);
    const conditions = ref([]);
    const references = ref([]);
    let leftTimer, rightTimer;
    function mouseup() {
      clearInterval(leftTimer);
      clearInterval(rightTimer);
    }
    function left() {
      var _a2;
      let el = (_a2 = conditionsRef.value) == null ? void 0 : _a2.$el;
      leftTimer = setInterval(() => {
        if (el)
          el.scrollLeft -= 15;
      }, 50);
    }
    function right() {
      var _a2;
      let el = (_a2 = conditionsRef.value) == null ? void 0 : _a2.$el;
      rightTimer = setInterval(() => {
        if (el)
          el.scrollLeft += 15;
      }, 50);
    }
    function change() {
      nextTick(() => {
        var _a2;
        let el = (_a2 = conditionsRef.value) == null ? void 0 : _a2.$el;
        scroll.value = el != null && (el == null ? void 0 : el.getBoundingClientRect().width) >= scrollWidth.value;
      });
      emit("filter", conditions.value);
    }
    function setConditions(conditionObj) {
      conditions.value = [];
      if (conditionObj) {
        Object.keys(conditionObj).forEach((key) => {
          let value = conditionObj[key].value;
          references.value.forEach((r) => {
            if (r.field === key) {
              r.init(value);
              const condition = r.getCondition();
              if (condition) {
                conditions.value.push(condition);
              }
            }
          });
        });
        change();
      }
    }
    function filter() {
      conditions.value = [];
      references.value.forEach((r) => {
        let condition;
        condition = r.getCondition();
        if (condition) {
          conditions.value.push(condition);
        }
      });
      drawer.value = false;
      change();
    }
    function open() {
      drawer.value = true;
    }
    function initComponents() {
      references.value.forEach((r) => {
        let condition = conditions.value.find((c) => c.field === r.field);
        r.init(condition == null ? void 0 : condition.value);
      });
    }
    function clear() {
      conditions.value = [];
      initComponents();
      change();
    }
    const scrollWidth = computed(() => {
      const el = filterRef.value;
      return el === null ? 0 : el.getBoundingClientRect().width - 210;
    });
    const show = computed(() => {
      return conditions.value.length > 0 && props.showEmpty === false || props.showEmpty;
    });
    provide(referenceKey$1, references);
    onMounted(() => {
      drawer.value = false;
    });
    expose({
      open,
      setConditions
    });
    return (_ctx, _cache) => {
      const _component_ArrowLeftBold = resolveComponent("ArrowLeftBold");
      const _component_el_icon = resolveComponent("el-icon");
      const _component_ArrowRightBold = resolveComponent("ArrowRightBold");
      const _component_Delete = resolveComponent("Delete");
      const _component_el_button = resolveComponent("el-button");
      const _component_el_drawer = resolveComponent("el-drawer");
      return openBlock(), createElementBlock(Fragment, null, [
        withDirectives(createElementVNode("div", {
          class: "fu-filter",
          ref_key: "filterRef",
          ref: filterRef
        }, [
          createElementVNode("div", _hoisted_1$n, [
            createTextVNode(toDisplayString(__props.count) + " ", 1),
            createElementVNode("span", _hoisted_2$f, toDisplayString(unref(t2)("fu.filter_bar.results")), 1)
          ]),
          _hoisted_3$d,
          scroll.value ? (openBlock(), createElementBlock("div", {
            key: 0,
            class: "fu-filter__scroll",
            onMousedown: left,
            onMouseup: mouseup
          }, [
            createVNode(_component_el_icon, null, {
              default: withCtx(() => [
                createVNode(_component_ArrowLeftBold)
              ]),
              _: 1
            })
          ], 32)) : createCommentVNode("v-if", true),
          createVNode(FuFilterConditions, {
            conditions: conditions.value,
            onChange: change,
            ref_key: "conditionsRef",
            ref: conditionsRef
          }, null, 8, ["conditions"]),
          scroll.value ? (openBlock(), createElementBlock("div", {
            key: 1,
            class: "fu-filter__scroll",
            onMousedown: right,
            onMouseup: mouseup
          }, [
            createVNode(_component_el_icon, null, {
              default: withCtx(() => [
                createVNode(_component_ArrowRightBold)
              ]),
              _: 1
            })
          ], 32)) : createCommentVNode("v-if", true),
          conditions.value.length > 0 ? (openBlock(), createElementBlock("div", {
            key: 2,
            class: "fu-filter__clear fu-scale-click",
            onClick: clear
          }, [
            createVNode(_component_el_icon, null, {
              default: withCtx(() => [
                createVNode(_component_Delete)
              ]),
              _: 1
            }),
            createTextVNode(" " + toDisplayString(unref(t2)("fu.filter_bar.clear")), 1)
          ])) : createCommentVNode("v-if", true)
        ], 512), [
          [vShow, unref(show)]
        ]),
        createVNode(_component_el_drawer, {
          size: __props.drawerWidth,
          class: "fu-filter__drawer",
          title: unref(t2)("fu.filter_bar.drawer_title"),
          modelValue: drawer.value,
          "onUpdate:modelValue": _cache[1] || (_cache[1] = ($event) => drawer.value = $event),
          onOpen: initComponents
        }, {
          default: withCtx(() => [
            createElementVNode("div", _hoisted_4$2, [
              renderSlot(_ctx.$slots, "default", {}, () => [
                (openBlock(true), createElementBlock(Fragment, null, renderList(__props.components, (c, i) => {
                  return openBlock(), createBlock(resolveDynamicComponent(c.component), mergeProps({ key: i }, c, { size: unref(configSize) }), null, 16, ["size"]);
                }), 128))
              ])
            ]),
            createElementVNode("div", _hoisted_5$1, [
              renderSlot(_ctx.$slots, "footer", {}, () => [
                createVNode(_component_el_button, {
                  size: __props.size,
                  onClick: _cache[0] || (_cache[0] = ($event) => drawer.value = false)
                }, {
                  default: withCtx(() => [
                    createTextVNode(toDisplayString(unref(t2)("fu.filter_bar.cancel")), 1)
                  ]),
                  _: 1
                }, 8, ["size"]),
                createVNode(_component_el_button, {
                  size: __props.size,
                  type: "primary",
                  onClick: filter
                }, {
                  default: withCtx(() => [
                    createTextVNode(toDisplayString(unref(t2)("fu.filter_bar.search")), 1)
                  ]),
                  _: 1
                }, 8, ["size"])
              ])
            ])
          ]),
          _: 3
        }, 8, ["size", "title", "modelValue"])
      ], 64);
    };
  }
}));
var FuFilter = /* @__PURE__ */ _export_sfc(_sfc_main$G, [["__file", "/Users/runner/work/fit2cloud-ui-plus/fit2cloud-ui-plus/src/components/filter-bar/FuFilter.vue"]]);
const _hoisted_1$m = { class: "fu-filter-bar" };
const _hoisted_2$e = { class: "fu-filter-bar__top" };
const _hoisted_3$c = { class: "top_left" };
const _hoisted_4$1 = { class: "top_right" };
const _hoisted_5 = { key: 0 };
const _hoisted_6 = { class: "fu-filter-bar__bottom" };
const __default__$s = { name: "FuFilterBar" };
const _sfc_main$F = /* @__PURE__ */ defineComponent(__spreadProps(__spreadValues({}, __default__$s), {
  props: {
    size: {
      type: String,
      validator: validateSize
    },
    resultCount: Number,
    quickPlaceholder: String,
    components: Array,
    showEmpty: {
      type: Boolean,
      default: false
    }
  },
  emits: ["exec"],
  setup(__props, { expose, emit }) {
    const { t: t2 } = useLocale();
    const configSize = useSize();
    const quick = ref("");
    const conditions = ref([]);
    const filterRef = ref();
    function open() {
      var _a2;
      (_a2 = filterRef.value) == null ? void 0 : _a2.open();
    }
    function change() {
      emit("exec", conditionObj.value);
    }
    function filter(c) {
      conditions.value = c;
      emit("exec", conditionObj.value);
    }
    function setConditions(conditionObj2) {
      var _a2;
      if (conditionObj2.quick) {
        quick.value = conditionObj2.quick;
      }
      (_a2 = filterRef.value) == null ? void 0 : _a2.setConditions(conditionObj2);
    }
    const conditionObj = computed(() => {
      let obj = {};
      if (quick.value) {
        obj.quick = quick.value;
      }
      conditions.value.forEach((c) => {
        obj[c.field] = c;
      });
      return obj;
    });
    expose({
      setConditions,
      open
    });
    return (_ctx, _cache) => {
      const _component_el_button = resolveComponent("el-button");
      return openBlock(), createElementBlock("div", _hoisted_1$m, [
        createElementVNode("div", _hoisted_2$e, [
          createElementVNode("div", _hoisted_3$c, [
            renderSlot(_ctx.$slots, "tl")
          ]),
          createElementVNode("div", _hoisted_4$1, [
            renderSlot(_ctx.$slots, "tr", { condition: unref(conditionObj) }, () => [
              createVNode(FuFilterInput, {
                size: unref(configSize),
                modelValue: quick.value,
                "onUpdate:modelValue": _cache[0] || (_cache[0] = ($event) => quick.value = $event),
                placeholder: __props.quickPlaceholder,
                onChange: change
              }, null, 8, ["size", "modelValue", "placeholder"])
            ]),
            createVNode(_component_el_button, {
              class: "fu-filter-button",
              onClick: open,
              icon: "Filter",
              size: unref(configSize)
            }, {
              default: withCtx(() => [
                createTextVNode(toDisplayString(unref(t2)("fu.filter_bar.filter")) + " ", 1),
                conditions.value.length > 0 ? (openBlock(), createElementBlock("span", _hoisted_5, "(" + toDisplayString(conditions.value.length) + ")", 1)) : createCommentVNode("v-if", true)
              ]),
              _: 1
            }, 8, ["size"]),
            renderSlot(_ctx.$slots, "buttons")
          ])
        ]),
        createElementVNode("div", _hoisted_6, [
          createVNode(FuFilter, {
            ref_key: "filterRef",
            ref: filterRef,
            onFilter: filter,
            count: __props.resultCount,
            components: __props.components,
            size: unref(configSize),
            "show-empty": __props.showEmpty
          }, {
            default: withCtx(() => [
              renderSlot(_ctx.$slots, "default")
            ]),
            _: 3
          }, 8, ["count", "components", "size", "show-empty"])
        ])
      ]);
    };
  }
}));
var FuFilterBar = /* @__PURE__ */ _export_sfc(_sfc_main$F, [["__file", "/Users/runner/work/fit2cloud-ui-plus/fit2cloud-ui-plus/src/components/filter-bar/FuFilterBar.vue"]]);
const _hoisted_1$l = ["onClick"];
const _sfc_main$E = /* @__PURE__ */ defineComponent({
  __name: "FuFilterOption",
  props: {
    value: {
      type: [String, Number, Boolean, Object],
      required: true
    },
    label: [String, Number],
    disabled: {
      type: Boolean,
      default: false
    }
  },
  setup(__props) {
    const props = __props;
    const select = inject(selectKey);
    const selected = computed(() => {
      if (!select)
        return false;
      if (Array.isArray(select.selection.value)) {
        return select.selection.value.includes(props.value);
      } else {
        return select.selection.value === props.value;
      }
    });
    function click() {
      select == null ? void 0 : select.setSelected(props.value, selected.value);
    }
    return (_ctx, _cache) => {
      return openBlock(), createElementBlock("div", {
        class: normalizeClass(["fu-filter-option", { "is-selected": unref(selected), "is-disabled": __props.disabled }]),
        onClick: withModifiers(click, ["stop"])
      }, toDisplayString(__props.label || __props.value), 11, _hoisted_1$l);
    };
  }
});
var FuFilterOption = /* @__PURE__ */ _export_sfc(_sfc_main$E, [["__file", "/Users/runner/work/fit2cloud-ui-plus/fit2cloud-ui-plus/src/components/filter-bar/filter-components/FuFilterOption.vue"]]);
const _hoisted_1$k = { class: "fu-filter-component" };
const _hoisted_2$d = { class: "fu-filter-component__label" };
const _hoisted_3$b = { class: "fu-filter-component__content" };
const _hoisted_4 = { class: "fu-filter-option" };
const __default__$r = { name: "FuFilterSelect" };
const _sfc_main$D = /* @__PURE__ */ defineComponent(__spreadProps(__spreadValues({}, __default__$r), {
  props: {
    size: {
      type: String,
      validator: validateSize
    },
    multiple: {
      type: Boolean,
      default: false
    },
    showLimit: {
      type: Number,
      default: 3
    },
    useSelectAll: {
      type: Boolean,
      default: false
    },
    label: String,
    field: {
      type: String,
      required: true
    },
    options: {
      type: Array,
      default: []
    }
  },
  emits: ["change"],
  setup(__props, { expose, emit }) {
    const props = __props;
    const selection = ref(props.multiple ? [] : "");
    const configSize = useSize();
    const showOptions = computed(() => {
      return props.options.filter((o, i) => {
        let show = props.showLimit < 0 ? true : i < props.showLimit;
        if (Array.isArray(selection.value)) {
          return show || selection.value.includes(o.value);
        } else {
          return show || selection.value === o.value;
        }
      });
    });
    const showMore = computed(() => {
      var _a2;
      return ((_a2 = props.options) == null ? void 0 : _a2.length) > props.showLimit && props.showLimit > 0;
    });
    const valueLabel = computed(() => {
      if (Array.isArray(selection.value)) {
        let values = [];
        selection.value.forEach((v) => {
          values.push(getValueLabel(v));
        });
        return values.join(", ");
      }
      return getValueLabel(selection.value);
    });
    const showSelectAll = computed(() => {
      return props.useSelectAll && props.multiple;
    });
    const { t: t2 } = useLocale();
    function change(v) {
      if (showSelectAll.value && (v == null ? void 0 : v.includes("-$SELECT-ALL$-"))) {
        selection.value = props.options.map((o) => o.value);
      }
      emit("change", selection.value);
    }
    function setSelected(value, selected) {
      if (!Array.isArray(selection.value)) {
        selection.value = selected ? "" : value;
        return;
      }
      if (selected) {
        let index = selection.value.indexOf(value);
        selection.value.splice(index, 1);
      } else {
        selection.value.push(value);
      }
    }
    function selectAll() {
      selection.value = props.options.map((o) => o.value);
    }
    function getValueLabel(value) {
      for (let o of props.options) {
        if (o.value === value) {
          return o.label;
        }
      }
      return value;
    }
    function getCondition() {
      if (!selection.value || Array.isArray(selection.value) && selection.value.length === 0)
        return;
      let { field: field2, label } = props;
      return { field: field2, label, value: selection.value, valueLabel: valueLabel.value };
    }
    function init(v) {
      selection.value = v !== void 0 ? v : props.multiple ? [] : "";
    }
    provide(selectKey, {
      setSelected,
      selection
    });
    const references = inject(referenceKey$1);
    const field = props.field;
    const reference = { field, init, getCondition };
    references == null ? void 0 : references.value.push(reference);
    expose({
      getCondition,
      init
    });
    return (_ctx, _cache) => {
      const _component_el_option = resolveComponent("el-option");
      const _component_el_select = resolveComponent("el-select");
      const _component_Plus = resolveComponent("Plus");
      const _component_el_icon = resolveComponent("el-icon");
      const _component_el_popover = resolveComponent("el-popover");
      return openBlock(), createElementBlock("div", _hoisted_1$k, [
        createElementVNode("div", _hoisted_2$d, toDisplayString(__props.label), 1),
        createElementVNode("div", _hoisted_3$b, [
          (openBlock(true), createElementBlock(Fragment, null, renderList(unref(showOptions), (o) => {
            return openBlock(), createBlock(FuFilterOption, {
              label: o.label,
              value: o.value,
              key: o.value
            }, null, 8, ["label", "value"]);
          }), 128)),
          unref(showMore) ? (openBlock(), createBlock(_component_el_popover, {
            key: 0,
            "popper-class": "fu-filter-component-popover",
            "show-arrow": false,
            placement: "bottom-start",
            trigger: "click",
            width: "240"
          }, {
            reference: withCtx(() => [
              createElementVNode("div", _hoisted_4, [
                createVNode(_component_el_icon, null, {
                  default: withCtx(() => [
                    createVNode(_component_Plus)
                  ]),
                  _: 1
                }),
                createTextVNode(" " + toDisplayString(unref(t2)("fu.filter_bar.more")), 1)
              ])
            ]),
            default: withCtx(() => [
              createVNode(_component_el_select, mergeProps({
                modelValue: selection.value,
                "onUpdate:modelValue": _cache[0] || (_cache[0] = ($event) => selection.value = $event)
              }, _ctx.$attrs, {
                multiple: __props.multiple,
                onChange: change,
                teleported: false,
                size: unref(configSize),
                placeholder: unref(t2)("fu.search_bar.please_select")
              }), {
                default: withCtx(() => [
                  unref(showSelectAll) ? (openBlock(), createBlock(_component_el_option, {
                    key: 0,
                    value: "-$SELECT-ALL$-"
                  }, {
                    default: withCtx(() => [
                      createElementVNode("div", { onClick: selectAll }, toDisplayString(unref(t2)("fu.filter_bar.select_all")), 1)
                    ]),
                    _: 1
                  })) : createCommentVNode("v-if", true),
                  (openBlock(true), createElementBlock(Fragment, null, renderList(__props.options, (o) => {
                    return openBlock(), createBlock(_component_el_option, {
                      label: o.label,
                      value: o.value,
                      key: o.value
                    }, null, 8, ["label", "value"]);
                  }), 128))
                ]),
                _: 1
              }, 16, ["modelValue", "multiple", "size", "placeholder"])
            ]),
            _: 1
          })) : createCommentVNode("v-if", true)
        ])
      ]);
    };
  }
}));
var FuFilterSelect = /* @__PURE__ */ _export_sfc(_sfc_main$D, [["__file", "/Users/runner/work/fit2cloud-ui-plus/fit2cloud-ui-plus/src/components/filter-bar/filter-components/FuFilterSelect.vue"]]);
const _hoisted_1$j = { class: "fu-filter-component" };
const _hoisted_2$c = { class: "fu-filter-component__label" };
const _hoisted_3$a = { class: "fu-filter-component__content" };
const __default__$q = { name: "FuFilterNormalSelect" };
const _sfc_main$C = /* @__PURE__ */ defineComponent(__spreadProps(__spreadValues({}, __default__$q), {
  props: {
    size: {
      type: String,
      validator: validateSize
    },
    multiple: {
      type: Boolean,
      default: false
    },
    useSelectAll: {
      type: Boolean,
      default: false
    },
    label: String,
    field: {
      type: String,
      required: true
    },
    options: {
      type: Array,
      default: []
    }
  },
  emits: ["change"],
  setup(__props, { expose, emit }) {
    const props = __props;
    const selection = ref(props.multiple ? [] : "");
    const configSize = useSize();
    const valueLabel = computed(() => {
      if (Array.isArray(selection.value)) {
        let values = [];
        selection.value.forEach((v) => {
          values.push(getValueLabel(v));
        });
        return values.join(", ");
      }
      return getValueLabel(selection.value);
    });
    const showSelectAll = computed(() => {
      return props.useSelectAll && props.multiple;
    });
    const { t: t2 } = useLocale();
    function change(v) {
      if (showSelectAll.value && (v == null ? void 0 : v.includes("-$SELECT-ALL$-"))) {
        selection.value = props.options.map((o) => o.value);
      }
      emit("change", selection.value);
    }
    function setSelected(value, selected) {
      if (!Array.isArray(selection.value)) {
        selection.value = selected ? "" : value;
        return;
      }
      if (selected) {
        let index = selection.value.indexOf(value);
        selection.value.splice(index, 1);
      } else {
        selection.value.push(value);
      }
    }
    function selectAll() {
      selection.value = props.options.map((o) => o.value);
    }
    function getValueLabel(value) {
      for (let o of props.options) {
        if (o.value === value) {
          return o.label;
        }
      }
      return value;
    }
    function getCondition() {
      if (!selection.value || Array.isArray(selection.value) && selection.value.length === 0)
        return;
      let { field: field2, label } = props;
      return { field: field2, label, value: selection.value, valueLabel: valueLabel.value };
    }
    function init(v) {
      selection.value = v !== void 0 ? v : props.multiple ? [] : "";
    }
    provide(selectKey, {
      setSelected,
      selection
    });
    const references = inject(referenceKey$1);
    const field = props.field;
    const reference = { field, init, getCondition };
    references == null ? void 0 : references.value.push(reference);
    expose({
      getCondition,
      init
    });
    return (_ctx, _cache) => {
      const _component_el_option = resolveComponent("el-option");
      const _component_el_select = resolveComponent("el-select");
      return openBlock(), createElementBlock("div", _hoisted_1$j, [
        createElementVNode("div", _hoisted_2$c, toDisplayString(__props.label), 1),
        createElementVNode("div", _hoisted_3$a, [
          createVNode(_component_el_select, mergeProps({
            modelValue: selection.value,
            "onUpdate:modelValue": _cache[0] || (_cache[0] = ($event) => selection.value = $event)
          }, _ctx.$attrs, {
            multiple: __props.multiple,
            onChange: change,
            teleported: false,
            size: unref(configSize),
            placeholder: unref(t2)("fu.search_bar.please_select"),
            class: "fu-filter-select"
          }), {
            default: withCtx(() => [
              unref(showSelectAll) ? (openBlock(), createBlock(_component_el_option, {
                key: 0,
                value: "-$SELECT-ALL$-"
              }, {
                default: withCtx(() => [
                  createElementVNode("div", { onClick: selectAll }, toDisplayString(unref(t2)("fu.filter_bar.select_all")), 1)
                ]),
                _: 1
              })) : createCommentVNode("v-if", true),
              (openBlock(true), createElementBlock(Fragment, null, renderList(__props.options, (o) => {
                return openBlock(), createBlock(_component_el_option, {
                  label: o.label,
                  value: o.value,
                  key: o.value
                }, null, 8, ["label", "value"]);
              }), 128))
            ]),
            _: 1
          }, 16, ["modelValue", "multiple", "size", "placeholder"])
        ])
      ]);
    };
  }
}));
var FuFilterNormalSelect = /* @__PURE__ */ _export_sfc(_sfc_main$C, [["__file", "/Users/runner/work/fit2cloud-ui-plus/fit2cloud-ui-plus/src/components/filter-bar/filter-components/FuFilterNormalSelect.vue"]]);
const getCheckDate = (timestamp) => {
  if (!timestamp)
    return false;
  const dt = new Date(timestamp);
  if (isNaN(dt.getTime()))
    return false;
  return dt;
};
const datetimeFormat = (timestamp) => {
  const dt = getCheckDate(timestamp);
  if (!dt)
    return timestamp;
  const y = dt.getFullYear();
  const m = (dt.getMonth() + 1 + "").padStart(2, "0");
  const d = (dt.getDate() + "").padStart(2, "0");
  const hh = (dt.getHours() + "").padStart(2, "0");
  const mm = (dt.getMinutes() + "").padStart(2, "0");
  const ss = (dt.getSeconds() + "").padStart(2, "0");
  return `${y}-${m}-${d} ${hh}:${mm}:${ss}`;
};
const dateFormat = (timestamp) => {
  const dt = getCheckDate(timestamp);
  if (!dt)
    return timestamp;
  const y = dt.getFullYear();
  const m = (dt.getMonth() + 1 + "").padStart(2, "0");
  const d = (dt.getDate() + "").padStart(2, "0");
  return `${y}-${m}-${d}`;
};
const _hoisted_1$i = { class: "fu-filter-component" };
const _hoisted_2$b = { class: "fu-filter-component__label" };
const _hoisted_3$9 = { class: "fu-filter-component__content" };
const __default__$p = { name: "FuFilterDate" };
const _sfc_main$B = /* @__PURE__ */ defineComponent(__spreadProps(__spreadValues({}, __default__$p), {
  props: {
    size: {
      type: String,
      validator: validateSize
    },
    label: String,
    field: {
      type: String,
      required: true
    },
    valueFormat: {
      type: String,
      default: "x"
    }
  },
  setup(__props, { expose }) {
    const props = __props;
    const value = ref([]);
    const configSize = useSize();
    const valueLabel = computed(() => {
      return dateFormat(value.value[0]) + " - " + dateFormat(value.value[1]);
    });
    const { t: t2 } = useLocale();
    function getCondition() {
      if (!value.value || value.value.length === 0)
        return;
      let { field: field2, label } = props;
      return { field: field2, label, value: value.value, valueLabel: valueLabel.value };
    }
    function init(v) {
      value.value = v !== void 0 ? v : [];
    }
    const references = inject(referenceKey$1);
    const field = props.field;
    const reference = { field, init, getCondition };
    references == null ? void 0 : references.value.push(reference);
    expose({
      getCondition,
      init
    });
    return (_ctx, _cache) => {
      const _component_el_date_picker = resolveComponent("el-date-picker");
      return openBlock(), createElementBlock("div", _hoisted_1$i, [
        createElementVNode("div", _hoisted_2$b, toDisplayString(__props.label), 1),
        createElementVNode("div", _hoisted_3$9, [
          createCommentVNode("configSize"),
          createVNode(_component_el_date_picker, mergeProps({
            class: "fu-filter-date",
            modelValue: value.value,
            "onUpdate:modelValue": _cache[0] || (_cache[0] = ($event) => value.value = $event)
          }, _ctx.$attrs, {
            size: unref(configSize),
            placeholder: unref(t2)("fu.search_bar.select_date"),
            type: "daterange",
            "value-format": __props.valueFormat,
            "start-placeholder": unref(t2)("fu.search_bar.start_date"),
            "end-placeholder": unref(t2)("fu.search_bar.end_date")
          }), null, 16, ["modelValue", "size", "placeholder", "value-format", "start-placeholder", "end-placeholder"])
        ])
      ]);
    };
  }
}));
var FuFilterDate = /* @__PURE__ */ _export_sfc(_sfc_main$B, [["__file", "/Users/runner/work/fit2cloud-ui-plus/fit2cloud-ui-plus/src/components/filter-bar/filter-components/FuFilterDate.vue"]]);
const _hoisted_1$h = { class: "fu-filter-component" };
const _hoisted_2$a = { class: "fu-filter-component__label" };
const _hoisted_3$8 = { class: "fu-filter-component__content" };
const __default__$o = { name: "FuFilterDateTime" };
const _sfc_main$A = /* @__PURE__ */ defineComponent(__spreadProps(__spreadValues({}, __default__$o), {
  props: {
    size: {
      type: String,
      validator: validateSize
    },
    label: String,
    field: {
      type: String,
      required: true
    },
    valueFormat: {
      type: String,
      default: "x"
    }
  },
  setup(__props, { expose }) {
    const props = __props;
    const value = ref([]);
    const configSize = useSize();
    const valueLabel = computed(() => {
      return datetimeFormat(value.value[0]) + " - " + datetimeFormat(value.value[1]);
    });
    const { t: t2 } = useLocale();
    function getCondition() {
      if (!value.value || value.value.length === 0)
        return;
      let { field: field2, label } = props;
      return { field: field2, label, value: value.value, valueLabel: valueLabel.value };
    }
    function init(v) {
      value.value = v !== void 0 ? v : [];
    }
    const references = inject(referenceKey$1);
    const field = props.field;
    const reference = { field, init, getCondition };
    references == null ? void 0 : references.value.push(reference);
    expose({
      getCondition,
      init
    });
    return (_ctx, _cache) => {
      const _component_el_date_picker = resolveComponent("el-date-picker");
      return openBlock(), createElementBlock("div", _hoisted_1$h, [
        createElementVNode("div", _hoisted_2$a, toDisplayString(__props.label), 1),
        createElementVNode("div", _hoisted_3$8, [
          createVNode(_component_el_date_picker, mergeProps({
            class: "fu-filter-date",
            modelValue: value.value,
            "onUpdate:modelValue": _cache[0] || (_cache[0] = ($event) => value.value = $event)
          }, _ctx.$attrs, {
            size: unref(configSize),
            placeholder: unref(t2)("fu.search_bar.select_date_time"),
            type: "datetimerange",
            "value-format": __props.valueFormat,
            "start-placeholder": unref(t2)("fu.search_bar.start_date_time"),
            "end-placeholder": unref(t2)("fu.search_bar.end_date_time")
          }), null, 16, ["modelValue", "size", "placeholder", "value-format", "start-placeholder", "end-placeholder"])
        ])
      ]);
    };
  }
}));
var FuFilterDateTime = /* @__PURE__ */ _export_sfc(_sfc_main$A, [["__file", "/Users/runner/work/fit2cloud-ui-plus/fit2cloud-ui-plus/src/components/filter-bar/filter-components/FuFilterDateTime.vue"]]);
const _hoisted_1$g = { class: "fu-filter-component" };
const _hoisted_2$9 = { class: "fu-filter-component__label" };
const _hoisted_3$7 = { class: "fu-filter-component__content" };
const __default__$n = { name: "FuFilterInputText" };
const _sfc_main$z = /* @__PURE__ */ defineComponent(__spreadProps(__spreadValues({}, __default__$n), {
  props: {
    size: {
      type: String,
      validator: validateSize
    },
    label: String,
    field: {
      type: String,
      required: true
    }
  },
  setup(__props, { expose }) {
    const props = __props;
    const value = ref("");
    const configSize = useSize();
    useLocale();
    function getCondition() {
      if (!String(value.value))
        return;
      let { field: field2, label } = props;
      return { field: field2, label, value: value.value, valueLabel: value.value };
    }
    function init(v) {
      value.value = v !== void 0 ? v : "";
    }
    const references = inject(referenceKey$1);
    const field = props.field;
    const reference = { field, init, getCondition };
    references == null ? void 0 : references.value.push(reference);
    expose({
      getCondition,
      init
    });
    return (_ctx, _cache) => {
      const _component_el_input = resolveComponent("el-input");
      return openBlock(), createElementBlock("div", _hoisted_1$g, [
        createElementVNode("div", _hoisted_2$9, toDisplayString(__props.label), 1),
        createElementVNode("div", _hoisted_3$7, [
          createVNode(_component_el_input, mergeProps({
            class: "fu-filter-input-text",
            modelValue: value.value,
            "onUpdate:modelValue": _cache[0] || (_cache[0] = ($event) => value.value = $event)
          }, _ctx.$attrs, { size: unref(configSize) }), null, 16, ["modelValue", "size"])
        ])
      ]);
    };
  }
}));
var FuFilterInputText = /* @__PURE__ */ _export_sfc(_sfc_main$z, [["__file", "/Users/runner/work/fit2cloud-ui-plus/fit2cloud-ui-plus/src/components/filter-bar/filter-components/FuFilterInputText.vue"]]);
FuFilterBar.install = (app) => {
  app.component(FuFilterBar.name, FuFilterBar);
  app.component(FuFilter.name, FuFilter);
  app.component(FuFilterInput.name, FuFilterInput);
  app.component(FuFilterSelect.name, FuFilterSelect);
  app.component(FuFilterNormalSelect.name, FuFilterNormalSelect);
  app.component(FuFilterDate.name, FuFilterDate);
  app.component(FuFilterDateTime.name, FuFilterDateTime);
  app.component(FuFilterInputText.name, FuFilterInputText);
};
var __glob_2_0 = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  "default": FuFilterBar
}, Symbol.toStringTag, { value: "Module" }));
const COMPONENTS_TYPE = ["default", "primary", "success", "warning", "danger", "info"];
const validateType = (value) => {
  if (!value)
    return true;
  if (COMPONENTS_TYPE.includes(value)) {
    return true;
  }
  console.error("types is not contains " + value);
  return false;
};
const _hoisted_1$f = ["tabindex"];
const __default__$m = { name: "FuIconButton" };
const _sfc_main$y = /* @__PURE__ */ defineComponent(__spreadProps(__spreadValues({}, __default__$m), {
  props: {
    name: String,
    size: {
      type: [Number, String],
      default: 20
    },
    color: String,
    loading: Boolean,
    disabled: Boolean,
    type: {
      type: String,
      validator: validateType
    },
    tabindex: {
      type: [String, Number],
      default: 0
    }
  },
  emits: ["click"],
  setup(__props, { emit }) {
    const props = __props;
    const typeClass = computed(() => {
      return props.type ? `fu-icon-button--${props.type}` : "";
    });
    function click(e) {
      if (!props.disabled) {
        emit("click", e);
      }
    }
    return (_ctx, _cache) => {
      const _component_el_icon = resolveComponent("el-icon");
      return openBlock(), createElementBlock("div", {
        class: normalizeClass(["fu-icon-button", [{ "is-disabled": __props.disabled }, unref(typeClass)]]),
        tabindex: __props.tabindex,
        onClick: click
      }, [
        renderSlot(_ctx.$slots, "default", {}, () => [
          createVNode(_component_el_icon, {
            color: __props.color,
            size: __props.size,
            class: normalizeClass({ "is-loading": __props.loading })
          }, {
            default: withCtx(() => [
              (openBlock(), createBlock(resolveDynamicComponent(__props.name)))
            ]),
            _: 1
          }, 8, ["color", "size", "class"])
        ])
      ], 10, _hoisted_1$f);
    };
  }
}));
var FuIconButton = /* @__PURE__ */ _export_sfc(_sfc_main$y, [["__file", "/Users/runner/work/fit2cloud-ui-plus/fit2cloud-ui-plus/src/components/icon-button/FuIconButton.vue"]]);
FuIconButton.install = (app) => {
  app.component(FuIconButton.name, FuIconButton);
};
var __glob_2_1 = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  "default": FuIconButton
}, Symbol.toStringTag, { value: "Module" }));
let getRandomValues;
const rnds8 = new Uint8Array(16);
function rng() {
  if (!getRandomValues) {
    getRandomValues = typeof crypto !== "undefined" && crypto.getRandomValues && crypto.getRandomValues.bind(crypto);
    if (!getRandomValues) {
      throw new Error("crypto.getRandomValues() not supported. See https://github.com/uuidjs/uuid#getrandomvalues-not-supported");
    }
  }
  return getRandomValues(rnds8);
}
const byteToHex = [];
for (let i = 0; i < 256; ++i) {
  byteToHex.push((i + 256).toString(16).slice(1));
}
function unsafeStringify(arr, offset = 0) {
  return byteToHex[arr[offset + 0]] + byteToHex[arr[offset + 1]] + byteToHex[arr[offset + 2]] + byteToHex[arr[offset + 3]] + "-" + byteToHex[arr[offset + 4]] + byteToHex[arr[offset + 5]] + "-" + byteToHex[arr[offset + 6]] + byteToHex[arr[offset + 7]] + "-" + byteToHex[arr[offset + 8]] + byteToHex[arr[offset + 9]] + "-" + byteToHex[arr[offset + 10]] + byteToHex[arr[offset + 11]] + byteToHex[arr[offset + 12]] + byteToHex[arr[offset + 13]] + byteToHex[arr[offset + 14]] + byteToHex[arr[offset + 15]];
}
const randomUUID = typeof crypto !== "undefined" && crypto.randomUUID && crypto.randomUUID.bind(crypto);
var native = {
  randomUUID
};
function v4(options, buf, offset) {
  if (native.randomUUID && !buf && !options) {
    return native.randomUUID();
  }
  options = options || {};
  const rnds = options.random || (options.rng || rng)();
  rnds[6] = rnds[6] & 15 | 64;
  rnds[8] = rnds[8] & 63 | 128;
  if (buf) {
    offset = offset || 0;
    for (let i = 0; i < 16; ++i) {
      buf[offset + i] = rnds[i];
    }
    return buf;
  }
  return unsafeStringify(rnds);
}
const TRIGGERS = ["manual", "onClick", "onDblclick"];
const _sfc_main$x = defineComponent({
  name: "FuReadWriteSwitch",
  props: {
    modelValue: Boolean,
    data: [String, Number, Boolean],
    writeTrigger: {
      type: String,
      default: "onClick",
      validator: (value) => {
        return TRIGGERS.includes(value);
      }
    }
  },
  setup(props, { slots, emit }) {
    const id = ref(v4());
    const write = ref(props.modelValue);
    watch(() => props.modelValue, (v) => {
      if (v === write.value)
        return;
      if (v) {
        switchWrite();
      } else {
        switchRead();
      }
    });
    function change() {
      emit("update:modelValue", write.value);
      emit("change", [props.data, write.value]);
    }
    function switchWrite() {
      write.value = true;
      nextTick(() => {
        const nid = document.getElementById(id.value);
        const input = nid == null ? void 0 : nid.querySelector("input");
        input == null ? void 0 : input.click();
        input == null ? void 0 : input.focus();
        const textarea = nid == null ? void 0 : nid.querySelector("textarea");
        textarea == null ? void 0 : textarea.focus();
        change();
      });
    }
    function switchRead() {
      write.value = false;
      change();
    }
    return () => {
      const context = {
        class: "fu-read-write-switch",
        id: id.value
      };
      if (!write.value && props.writeTrigger !== TRIGGERS[0]) {
        context[props.writeTrigger] = switchWrite;
      }
      let children = props.data;
      if (!write.value && slots.read) {
        children = slots.read({
          write: switchWrite
        });
      }
      if (write.value && slots.default) {
        children = slots.default({
          read: switchRead
        });
      }
      return h("div", context, children);
    };
  }
});
var FuReadWriteSwitch = /* @__PURE__ */ _export_sfc(_sfc_main$x, [["__file", "/Users/runner/work/fit2cloud-ui-plus/fit2cloud-ui-plus/src/components/read-write-switch/FuReadWriteSwitch.vue"]]);
const __default__$l = { name: "FuInputRwSwitch" };
const _sfc_main$w = /* @__PURE__ */ defineComponent(__spreadProps(__spreadValues({}, __default__$l), {
  props: {
    modelValue: [String, Number],
    writeTrigger: {
      type: String,
      default: "onClick",
      validator: (value) => {
        return ["onClick", "onDblclick"].includes(value);
      }
    }
  },
  emits: ["input", "blur"],
  setup(__props, { emit }) {
    const props = __props;
    const data = ref(props.modelValue);
    watch(() => props.modelValue, (v) => {
      data.value = v;
    });
    function input(e) {
      emit("input", data.value, e);
    }
    function blur(read, e) {
      emit("blur", data.value, e);
      read();
    }
    function keydown(read, e) {
      if (e.key === "Enter") {
        read();
      }
    }
    return (_ctx, _cache) => {
      const _component_el_input = resolveComponent("el-input");
      return openBlock(), createBlock(FuReadWriteSwitch, {
        "write-trigger": __props.writeTrigger,
        data: data.value
      }, {
        default: withCtx(({ read }) => [
          createVNode(_component_el_input, mergeProps({
            modelValue: data.value,
            "onUpdate:modelValue": _cache[0] || (_cache[0] = ($event) => data.value = $event)
          }, _ctx.$attrs, {
            onInput: input,
            onBlur: ($event) => blur(read, $event),
            onKeydown: ($event) => keydown(read, $event)
          }), null, 16, ["modelValue", "onBlur", "onKeydown"])
        ]),
        _: 1
      }, 8, ["write-trigger", "data"]);
    };
  }
}));
var FuInputRwSwitch = /* @__PURE__ */ _export_sfc(_sfc_main$w, [["__file", "/Users/runner/work/fit2cloud-ui-plus/fit2cloud-ui-plus/src/components/read-write-switch/FuInputRwSwitch.vue"]]);
const __default__$k = { name: "FuSelectRwSwitch" };
const _sfc_main$v = /* @__PURE__ */ defineComponent(__spreadProps(__spreadValues({}, __default__$k), {
  props: {
    modelValue: [String, Number],
    options: {
      type: Array,
      default: []
    },
    blurTime: {
      type: Number,
      default: 150
    },
    writeTrigger: {
      type: String,
      default: "onClick",
      validator: (value) => {
        return ["onClick", "onDblclick"].includes(value);
      }
    }
  },
  emits: ["input", "blur", "change", "update:modelValue"],
  setup(__props, { emit }) {
    const props = __props;
    const data = ref(props.modelValue);
    watch(() => props.modelValue, (v) => {
      data.value = v;
    });
    function input(e) {
      emit("input", data.value, e);
    }
    function blur(read, e) {
      if (props.blurTime > 0) {
        setTimeout(() => {
          read();
        }, props.blurTime);
        emit("blur", e);
      }
    }
    function change(read, e) {
      emit("update:modelValue", data.value, e);
      emit("change", data.value, e);
      read();
    }
    return (_ctx, _cache) => {
      const _component_el_option = resolveComponent("el-option");
      const _component_el_select = resolveComponent("el-select");
      return openBlock(), createBlock(FuReadWriteSwitch, {
        "write-trigger": __props.writeTrigger,
        data: data.value
      }, {
        read: withCtx(() => [
          renderSlot(_ctx.$slots, "read", {}, () => [
            createTextVNode(toDisplayString(data.value), 1)
          ])
        ]),
        default: withCtx(({ read }) => [
          createVNode(_component_el_select, mergeProps({
            modelValue: data.value,
            "onUpdate:modelValue": _cache[0] || (_cache[0] = ($event) => data.value = $event)
          }, _ctx.$attrs, {
            onInput: input,
            onBlur: ($event) => blur(read, $event),
            onChange: ($event) => change(read, $event)
          }), {
            default: withCtx(() => [
              renderSlot(_ctx.$slots, "default", {}, () => [
                (openBlock(true), createElementBlock(Fragment, null, renderList(__props.options, (item) => {
                  return openBlock(), createBlock(_component_el_option, {
                    key: item.value,
                    label: item.label,
                    value: item.value
                  }, null, 8, ["label", "value"]);
                }), 128))
              ])
            ]),
            _: 2
          }, 1040, ["modelValue", "onBlur", "onChange"])
        ]),
        _: 3
      }, 8, ["write-trigger", "data"]);
    };
  }
}));
var FuSelectRwSwitch = /* @__PURE__ */ _export_sfc(_sfc_main$v, [["__file", "/Users/runner/work/fit2cloud-ui-plus/fit2cloud-ui-plus/src/components/read-write-switch/FuSelectRwSwitch.vue"]]);
FuReadWriteSwitch.install = (app) => {
  app.component(FuReadWriteSwitch.name, FuReadWriteSwitch);
  app.component(FuInputRwSwitch.name, FuInputRwSwitch);
  app.component(FuSelectRwSwitch.name, FuSelectRwSwitch);
};
var __glob_2_2 = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  "default": FuReadWriteSwitch
}, Symbol.toStringTag, { value: "Module" }));
const _hoisted_1$e = ["placeholder"];
const __default__$j = { name: "FuQuickSearch" };
const _sfc_main$u = /* @__PURE__ */ defineComponent(__spreadProps(__spreadValues({}, __default__$j), {
  props: {
    size: {
      type: String,
      validator: validateSize
    },
    modelValue: String,
    placeholder: String,
    useIcon: {
      type: Boolean,
      default: true
    }
  },
  emits: ["update:modelValue", "change"],
  setup(__props, { emit }) {
    const props = __props;
    const focused = ref(false);
    const configSize = useSize();
    const value = computed({
      get: () => props.modelValue,
      set: (val) => {
        emit("update:modelValue", val);
      }
    });
    function focus() {
      focused.value = true;
    }
    function blur(e) {
      if (focused.value) {
        emit("change", value.value, e);
      }
      focused.value = false;
    }
    function keydown(e) {
      const { code } = e;
      if (code === "Enter") {
        focused.value = false;
        emit("change", value.value, e);
      }
    }
    return (_ctx, _cache) => {
      const _component_Search = resolveComponent("Search");
      const _component_el_icon = resolveComponent("el-icon");
      return openBlock(), createElementBlock("div", {
        class: normalizeClass(["fu-quick-search", "fu-quick-search--" + unref(configSize)])
      }, [
        __props.useIcon ? (openBlock(), createBlock(_component_el_icon, { key: 0 }, {
          default: withCtx(() => [
            createVNode(_component_Search)
          ]),
          _: 1
        })) : createCommentVNode("v-if", true),
        createElementVNode("label", null, [
          withDirectives(createElementVNode("input", {
            placeholder: __props.placeholder,
            "onUpdate:modelValue": _cache[0] || (_cache[0] = ($event) => isRef(value) ? value.value = $event : null),
            onBlur: blur,
            onFocus: focus,
            onKeydown: keydown
          }, null, 40, _hoisted_1$e), [
            [vModelText, unref(value)]
          ])
        ])
      ], 2);
    };
  }
}));
var FuQuickSearch = /* @__PURE__ */ _export_sfc(_sfc_main$u, [["__file", "/Users/runner/work/fit2cloud-ui-plus/fit2cloud-ui-plus/src/components/search-bar/FuQuickSearch.vue"]]);
const referenceKey = Symbol("ReferenceKey");
const _hoisted_1$d = { class: "fu-complex-components" };
const _hoisted_2$8 = { class: "fu-complex-components__body" };
const _hoisted_3$6 = { class: "fu-complex-components__footer" };
const __default__$i = { name: "FuComplexSearch" };
const _sfc_main$t = /* @__PURE__ */ defineComponent(__spreadProps(__spreadValues({}, __default__$i), {
  props: {
    size: {
      type: String,
      validator: validateSize
    },
    components: Array
  },
  emits: ["close", "change"],
  setup(__props, { expose, emit }) {
    const active = ref(false);
    const references = inject(referenceKey);
    const configSize = useSize();
    const showComplex = computed(() => {
      return references ? references.value.length > 0 : false;
    });
    const { t: t2 } = useLocale();
    function hide() {
      emit("close");
    }
    function toggle() {
      active.value = !active.value;
      if (active.value) {
        references == null ? void 0 : references.value.forEach((r) => r.init());
      }
    }
    function close() {
      active.value = false;
    }
    function ok() {
      close();
      exec();
    }
    function exec() {
      let conditions = [];
      references == null ? void 0 : references.value.forEach((r) => {
        let condition = r.getCondition();
        if ((condition == null ? void 0 : condition.value) !== void 0) {
          conditions.push(condition);
        }
      });
      emit("change", conditions);
    }
    function setConditions(conditionObj) {
      let result = [];
      if (conditionObj) {
        Object.keys(conditionObj).forEach((key) => {
          let c = conditionObj[key];
          references == null ? void 0 : references.value.forEach((r) => {
            if (r.field === key) {
              r.init(c.value);
              const condition = r.getCondition();
              if (condition) {
                result.push(condition);
              }
            }
          });
        });
      }
      return result;
    }
    expose({
      setConditions,
      close
    });
    return (_ctx, _cache) => {
      const _component_el_button = resolveComponent("el-button");
      const _component_el_popover = resolveComponent("el-popover");
      return openBlock(), createBlock(_component_el_popover, {
        visible: active.value,
        "show-arrow": false,
        onHide: hide,
        width: "auto",
        "popper-class": "fu-complex-components"
      }, {
        reference: withCtx(() => [
          withDirectives(createVNode(_component_el_button, {
            circle: "",
            icon: "ArrowRightBold",
            onClick: toggle,
            size: unref(configSize),
            class: normalizeClass(["fu-complex-components-trigger", { "is-active": active.value }])
          }, null, 8, ["size", "class"]), [
            [vShow, unref(showComplex)]
          ])
        ]),
        default: withCtx(() => [
          createElementVNode("div", _hoisted_1$d, [
            createElementVNode("div", _hoisted_2$8, [
              renderSlot(_ctx.$slots, "default", {}, () => [
                (openBlock(true), createElementBlock(Fragment, null, renderList(__props.components, (c) => {
                  return openBlock(), createBlock(resolveDynamicComponent(c.component), mergeProps(c, { size: unref(configSize) }), null, 16, ["size"]);
                }), 256))
              ])
            ]),
            createElementVNode("div", _hoisted_3$6, [
              createVNode(_component_el_button, {
                onClick: close,
                size: unref(configSize)
              }, {
                default: withCtx(() => [
                  createTextVNode(toDisplayString(unref(t2)("fu.search_bar.cancel")), 1)
                ]),
                _: 1
              }, 8, ["size"]),
              createVNode(_component_el_button, {
                type: "primary",
                onClick: ok,
                size: unref(configSize)
              }, {
                default: withCtx(() => [
                  createTextVNode(toDisplayString(unref(t2)("fu.search_bar.ok")), 1)
                ]),
                _: 1
              }, 8, ["size"])
            ])
          ])
        ]),
        _: 3
      }, 8, ["visible"]);
    };
  }
}));
var FuComplexSearch = /* @__PURE__ */ _export_sfc(_sfc_main$t, [["__file", "/Users/runner/work/fit2cloud-ui-plus/fit2cloud-ui-plus/src/components/search-bar/FuComplexSearch.vue"]]);
const __default__$h = { name: "FuSearchBarButton" };
const _sfc_main$s = /* @__PURE__ */ defineComponent(__spreadProps(__spreadValues({}, __default__$h), {
  props: {
    size: {
      type: String,
      validator: validateSize
    },
    tooltip: String
  },
  setup(__props) {
    const configSize = useSize();
    return (_ctx, _cache) => {
      const _component_el_button = resolveComponent("el-button");
      const _component_el_tooltip = resolveComponent("el-tooltip");
      return openBlock(), createBlock(_component_el_tooltip, {
        content: __props.tooltip,
        disabled: !__props.tooltip
      }, {
        default: withCtx(() => [
          createVNode(_component_el_button, mergeProps({
            class: "fu-search-bar-button",
            circle: "",
            size: unref(configSize)
          }, _ctx.$attrs), null, 16, ["size"])
        ]),
        _: 1
      }, 8, ["content", "disabled"]);
    };
  }
}));
var FuSearchBarButton = /* @__PURE__ */ _export_sfc(_sfc_main$s, [["__file", "/Users/runner/work/fit2cloud-ui-plus/fit2cloud-ui-plus/src/components/search-bar/FuSearchBarButton.vue"]]);
const _hoisted_1$c = { class: "fu-search-conditions__item" };
const _hoisted_2$7 = { key: 0 };
const _hoisted_3$5 = { class: "condition-value" };
const __default__$g = { name: "FuSearchConditions" };
const _sfc_main$r = /* @__PURE__ */ defineComponent(__spreadProps(__spreadValues({}, __default__$g), {
  props: {
    size: {
      type: String,
      validator: validateSize
    },
    conditions: {
      type: Array,
      required: true
    }
  },
  emits: ["change"],
  setup(__props, { emit }) {
    const props = __props;
    const configSize = useSize();
    function remove(index) {
      props.conditions.splice(index, 1);
      emit("change", props.conditions);
    }
    return (_ctx, _cache) => {
      const _component_Close = resolveComponent("Close");
      const _component_el_icon = resolveComponent("el-icon");
      return openBlock(), createElementBlock("div", {
        class: normalizeClass(["fu-search-conditions", "fu-search-conditions--" + unref(configSize)])
      }, [
        (openBlock(true), createElementBlock(Fragment, null, renderList(__props.conditions, (condition, index) => {
          return openBlock(), createElementBlock("div", _hoisted_1$c, [
            condition.label ? (openBlock(), createElementBlock("div", _hoisted_2$7, toDisplayString(condition.label), 1)) : createCommentVNode("v-if", true),
            createElementVNode("div", _hoisted_3$5, toDisplayString(condition.valueLabel), 1),
            createVNode(_component_el_icon, {
              class: "condition-remove",
              onClick: ($event) => remove(index)
            }, {
              default: withCtx(() => [
                createVNode(_component_Close)
              ]),
              _: 2
            }, 1032, ["onClick"])
          ]);
        }), 256))
      ], 2);
    };
  }
}));
var FuSearchConditions = /* @__PURE__ */ _export_sfc(_sfc_main$r, [["__file", "/Users/runner/work/fit2cloud-ui-plus/fit2cloud-ui-plus/src/components/search-bar/FuSearchContions.vue"]]);
const _hoisted_1$b = { class: "fu-search-bar" };
const _hoisted_2$6 = { class: "fu-search-bar__content" };
const _hoisted_3$4 = { class: "fu-search-bar__buttons" };
const __default__$f = { name: "FuSearchBar" };
const _sfc_main$q = /* @__PURE__ */ defineComponent(__spreadProps(__spreadValues({}, __default__$f), {
  props: {
    size: useSizeProp,
    quickKey: {
      type: String,
      default: "quick"
    },
    quickPlaceholder: String,
    useCleanButton: {
      type: Boolean,
      default: true
    },
    useRefreshButton: {
      type: Boolean,
      default: false
    },
    useQuickSearch: {
      type: Boolean,
      default: true
    },
    components: Array
  },
  emits: ["close", "exec"],
  setup(__props, { expose, emit }) {
    const props = __props;
    const complexRef = ref(null);
    const quick = ref("");
    const conditions = ref([]);
    const references = ref([]);
    provide(referenceKey, references);
    const configSize = useSize();
    const placeholder = computed(() => {
      return props.quickPlaceholder ? props.quickPlaceholder : t2("fu.search_bar.search");
    });
    const showComplex = computed(() => {
      return references.value.length > 0;
    });
    const showClean = computed(() => {
      return props.useCleanButton && (conditions.value.length > 0 || quick.value);
    });
    const showRefresh = computed(() => {
      return props.useRefreshButton && showComplex.value;
    });
    const condition = computed(() => {
      var _a2;
      const obj = {};
      if (quick.value) {
        obj[props.quickKey] = quick.value;
      }
      if (((_a2 = conditions.value) == null ? void 0 : _a2.length) > 0) {
        conditions.value.forEach((c) => {
          const { field, value } = c;
          obj[c.field] = { field, value };
        });
      }
      return obj;
    });
    const { t: t2 } = useLocale();
    function closePopover() {
      emit("close");
    }
    function clean() {
      quick.value = "";
      conditions.value = [];
      emit("exec", condition.value);
    }
    function change(ccs) {
      conditions.value = merge(conditions.value, ccs);
      exec();
    }
    function refresh() {
      var _a2;
      (_a2 = complexRef.value) == null ? void 0 : _a2.close();
      exec();
    }
    function exec() {
      emit("exec", condition.value);
    }
    function merge(source, target) {
      let conditions2 = source.concat(target);
      let conditionMap = /* @__PURE__ */ new Map();
      for (let condition2 of conditions2) {
        conditionMap.set(condition2.field, condition2);
      }
      let result = [];
      conditionMap.forEach((v) => {
        result.push(v);
      });
      return result;
    }
    function setConditions(conditionObj) {
      var _a2;
      conditions.value = ((_a2 = complexRef.value) == null ? void 0 : _a2.setConditions(conditionObj)) || [];
      if (props.useQuickSearch && conditionObj[props.quickKey] !== void 0) {
        quick.value = conditionObj[props.quickKey].value;
        exec();
      } else {
        refresh();
      }
    }
    expose({
      setConditions
    });
    return (_ctx, _cache) => {
      return openBlock(), createElementBlock("div", _hoisted_1$b, [
        createElementVNode("div", _hoisted_2$6, [
          createVNode(FuComplexSearch, {
            ref_key: "complexRef",
            ref: complexRef,
            components: __props.components,
            onChange: change,
            size: unref(configSize),
            onClose: closePopover
          }, {
            default: withCtx(() => [
              renderSlot(_ctx.$slots, "complex")
            ]),
            _: 3
          }, 8, ["components", "size"]),
          unref(showComplex) ? (openBlock(), createBlock(FuSearchConditions, {
            key: 0,
            conditions: conditions.value,
            size: unref(configSize),
            onChange: change
          }, null, 8, ["conditions", "size"])) : createCommentVNode("v-if", true),
          __props.useQuickSearch ? (openBlock(), createBlock(FuQuickSearch, {
            key: 1,
            size: unref(configSize),
            "use-icon": !unref(showComplex),
            placeholder: unref(placeholder),
            modelValue: quick.value,
            "onUpdate:modelValue": _cache[0] || (_cache[0] = ($event) => quick.value = $event),
            onChange: exec
          }, null, 8, ["size", "use-icon", "placeholder", "modelValue"])) : createCommentVNode("v-if", true)
        ]),
        createElementVNode("div", _hoisted_3$4, [
          renderSlot(_ctx.$slots, "buttons", {}, () => [
            unref(showClean) ? (openBlock(), createBlock(FuSearchBarButton, {
              key: 0,
              icon: "Close",
              onClick: clean,
              size: unref(configSize),
              tooltip: unref(t2)("fu.search_bar.clean")
            }, null, 8, ["size", "tooltip"])) : createCommentVNode("v-if", true),
            unref(showRefresh) ? (openBlock(), createBlock(FuSearchBarButton, {
              key: 1,
              icon: "Refresh",
              onClick: refresh,
              size: unref(configSize),
              tooltip: unref(t2)("fu.search_bar.refresh")
            }, null, 8, ["size", "tooltip"])) : createCommentVNode("v-if", true),
            renderSlot(_ctx.$slots, "default")
          ])
        ])
      ]);
    };
  }
}));
var FuSearchBar = /* @__PURE__ */ _export_sfc(_sfc_main$q, [["__file", "/Users/runner/work/fit2cloud-ui-plus/fit2cloud-ui-plus/src/components/search-bar/FuSearchBar.vue"]]);
const _hoisted_1$a = { class: "fu-complex-component" };
const _hoisted_2$5 = { class: "fu-complex-component__label" };
const _hoisted_3$3 = { class: "fu-complex-component__content" };
const __default__$e = { name: "FuComplexSelect" };
const _sfc_main$p = /* @__PURE__ */ defineComponent(__spreadProps(__spreadValues({}, __default__$e), {
  props: {
    size: {
      type: String,
      validator: validateSize
    },
    multiple: {
      type: Boolean,
      default: false
    },
    label: String,
    field: {
      type: String,
      required: true
    },
    options: {
      type: Array,
      default: []
    }
  },
  emits: ["init"],
  setup(__props, { expose, emit }) {
    const props = __props;
    const selection = ref(props.multiple ? [] : "");
    const configSize = useSize();
    const valueLabel = computed(() => {
      if (Array.isArray(selection.value)) {
        let values = [];
        selection.value.forEach((v) => {
          values.push(getValueLabel(v));
        });
        return values.join(", ");
      }
      return getValueLabel(selection.value);
    });
    const { t: t2 } = useLocale();
    function getValueLabel(value) {
      for (let o of props.options) {
        if (o.value === value) {
          return o.label;
        }
      }
      return value;
    }
    function getCondition() {
      if (!selection.value || Array.isArray(selection.value) && selection.value.length === 0)
        return;
      let { field: field2, label } = props;
      return { field: field2, label, value: selection.value, valueLabel: valueLabel.value };
    }
    function init(v) {
      selection.value = v !== void 0 ? v : props.multiple ? [] : "";
      emit("init");
    }
    const references = inject(referenceKey);
    const field = props.field;
    const reference = { field, init, getCondition };
    references == null ? void 0 : references.value.push(reference);
    expose({
      getCondition,
      init
    });
    return (_ctx, _cache) => {
      const _component_el_option = resolveComponent("el-option");
      const _component_el_select = resolveComponent("el-select");
      return openBlock(), createElementBlock("div", _hoisted_1$a, [
        createElementVNode("div", _hoisted_2$5, toDisplayString(__props.label), 1),
        createElementVNode("div", _hoisted_3$3, [
          createVNode(_component_el_select, mergeProps({
            class: "fu-complex-select",
            placeholder: unref(t2)("fu.search_bar.please_select"),
            modelValue: selection.value,
            "onUpdate:modelValue": _cache[0] || (_cache[0] = ($event) => selection.value = $event),
            size: unref(configSize)
          }, _ctx.$attrs, { clearable: "" }), {
            default: withCtx(() => [
              (openBlock(true), createElementBlock(Fragment, null, renderList(__props.options, (o) => {
                return openBlock(), createBlock(_component_el_option, {
                  key: o.value,
                  label: o.label,
                  value: o.value
                }, null, 8, ["label", "value"]);
              }), 128))
            ]),
            _: 1
          }, 16, ["placeholder", "modelValue", "size"])
        ])
      ]);
    };
  }
}));
var FuComplexSelect = /* @__PURE__ */ _export_sfc(_sfc_main$p, [["__file", "/Users/runner/work/fit2cloud-ui-plus/fit2cloud-ui-plus/src/components/search-bar/complex-components/FuComplexSelect.vue"]]);
const _hoisted_1$9 = { class: "fu-complex-component" };
const _hoisted_2$4 = { class: "fu-complex-component__label" };
const _hoisted_3$2 = { class: "fu-complex-component__content" };
const __default__$d = { name: "FuComplexInput" };
const _sfc_main$o = /* @__PURE__ */ defineComponent(__spreadProps(__spreadValues({}, __default__$d), {
  props: {
    size: {
      type: String,
      validator: validateSize
    },
    label: String,
    field: {
      type: String,
      required: true
    }
  },
  setup(__props, { expose }) {
    const props = __props;
    const inputValue = ref("");
    const configSize = useSize();
    const { t: t2 } = useLocale();
    function getCondition() {
      if (!inputValue.value)
        return;
      let { field: field2, label } = props;
      let value = inputValue.value;
      let valueLabel = inputValue.value;
      return { field: field2, label, value, valueLabel };
    }
    function init(v) {
      inputValue.value = v !== void 0 ? v : "";
    }
    const references = inject(referenceKey);
    const field = props.field;
    const reference = { field, init, getCondition };
    references == null ? void 0 : references.value.push(reference);
    expose({
      getCondition,
      init
    });
    return (_ctx, _cache) => {
      const _component_el_input = resolveComponent("el-input");
      return openBlock(), createElementBlock("div", _hoisted_1$9, [
        createElementVNode("div", _hoisted_2$4, toDisplayString(__props.label), 1),
        createElementVNode("div", _hoisted_3$2, [
          createVNode(_component_el_input, mergeProps({
            modelValue: inputValue.value,
            "onUpdate:modelValue": _cache[0] || (_cache[0] = ($event) => inputValue.value = $event),
            placeholder: unref(t2)("fu.search_bar.please_input"),
            size: unref(configSize)
          }, _ctx.$attrs), null, 16, ["modelValue", "placeholder", "size"])
        ])
      ]);
    };
  }
}));
var FuComplexInput = /* @__PURE__ */ _export_sfc(_sfc_main$o, [["__file", "/Users/runner/work/fit2cloud-ui-plus/fit2cloud-ui-plus/src/components/search-bar/complex-components/FuComplexInput.vue"]]);
const _hoisted_1$8 = { class: "fu-complex-component" };
const _hoisted_2$3 = { class: "fu-complex-component__label" };
const _hoisted_3$1 = { class: "fu-complex-component__content" };
const __default__$c = { name: "FuComplexDate" };
const _sfc_main$n = /* @__PURE__ */ defineComponent(__spreadProps(__spreadValues({}, __default__$c), {
  props: {
    size: {
      type: String,
      validator: validateSize
    },
    label: String,
    field: {
      type: String,
      required: true
    },
    valueFormat: {
      type: String,
      default: "x"
    }
  },
  setup(__props, { expose }) {
    const props = __props;
    const value = ref("");
    const valueLabel = computed(() => {
      return dateFormat(value.value[0]) + " ~ " + dateFormat(value.value[1]);
    });
    const { t: t2 } = useLocale();
    const configSize = useSize();
    function getCondition() {
      if (!String(value.value))
        return;
      let { field: field2, label } = props;
      return { field: field2, label, value: value.value, valueLabel: valueLabel.value };
    }
    function init(v) {
      value.value = v !== void 0 ? v : "";
    }
    const references = inject(referenceKey);
    const field = props.field;
    const reference = { field, init, getCondition };
    references == null ? void 0 : references.value.push(reference);
    expose({
      getCondition,
      init
    });
    return (_ctx, _cache) => {
      const _component_el_date_picker = resolveComponent("el-date-picker");
      return openBlock(), createElementBlock("div", _hoisted_1$8, [
        createElementVNode("div", _hoisted_2$3, toDisplayString(__props.label), 1),
        createElementVNode("div", _hoisted_3$1, [
          createVNode(_component_el_date_picker, mergeProps({
            class: "fu-complex-date",
            modelValue: value.value,
            "onUpdate:modelValue": _cache[0] || (_cache[0] = ($event) => value.value = $event)
          }, _ctx.$attrs, {
            size: unref(configSize),
            placeholder: unref(t2)("fu.search_bar.select_date"),
            type: "daterange",
            "value-format": __props.valueFormat,
            "start-placeholder": unref(t2)("fu.search_bar.start_date"),
            "end-placeholder": unref(t2)("fu.search_bar.end_date")
          }), null, 16, ["modelValue", "size", "placeholder", "value-format", "start-placeholder", "end-placeholder"])
        ])
      ]);
    };
  }
}));
var FuComplexDate = /* @__PURE__ */ _export_sfc(_sfc_main$n, [["__file", "/Users/runner/work/fit2cloud-ui-plus/fit2cloud-ui-plus/src/components/search-bar/complex-components/FuComplexDate.vue"]]);
const _hoisted_1$7 = { class: "fu-complex-component" };
const _hoisted_2$2 = { class: "fu-complex-component__label" };
const _hoisted_3 = { class: "fu-complex-component__content" };
const __default__$b = { name: "FuComplexDateTime" };
const _sfc_main$m = /* @__PURE__ */ defineComponent(__spreadProps(__spreadValues({}, __default__$b), {
  props: {
    size: {
      type: String,
      validator: validateSize
    },
    label: String,
    field: {
      type: String,
      required: true
    },
    valueFormat: {
      type: String,
      default: "x"
    }
  },
  setup(__props, { expose }) {
    const props = __props;
    const value = ref("");
    const configSize = useSize();
    const valueLabel = computed(() => {
      return datetimeFormat(value.value[0]) + " ~ " + datetimeFormat(value.value[1]);
    });
    const { t: t2 } = useLocale();
    function getCondition() {
      if (!String(value.value))
        return;
      let { field: field2, label } = props;
      return { field: field2, label, value: value.value, valueLabel: valueLabel.value };
    }
    function init(v) {
      value.value = v !== void 0 ? v : "";
    }
    const references = inject(referenceKey);
    const field = props.field;
    const reference = { field, init, getCondition };
    references == null ? void 0 : references.value.push(reference);
    expose({
      getCondition,
      init
    });
    return (_ctx, _cache) => {
      const _component_el_date_picker = resolveComponent("el-date-picker");
      return openBlock(), createElementBlock("div", _hoisted_1$7, [
        createElementVNode("div", _hoisted_2$2, toDisplayString(__props.label), 1),
        createElementVNode("div", _hoisted_3, [
          createVNode(_component_el_date_picker, mergeProps({
            class: "fu-complex-date-time",
            modelValue: value.value,
            "onUpdate:modelValue": _cache[0] || (_cache[0] = ($event) => value.value = $event)
          }, _ctx.$attrs, {
            size: unref(configSize),
            placeholder: unref(t2)("fu.search_bar.select_date_time"),
            type: "datetimerange",
            "value-format": __props.valueFormat,
            "start-placeholder": unref(t2)("fu.search_bar.start_date_time"),
            "end-placeholder": unref(t2)("fu.search_bar.end_date_time")
          }), null, 16, ["modelValue", "size", "placeholder", "value-format", "start-placeholder", "end-placeholder"])
        ])
      ]);
    };
  }
}));
var FuComplexDateTime = /* @__PURE__ */ _export_sfc(_sfc_main$m, [["__file", "/Users/runner/work/fit2cloud-ui-plus/fit2cloud-ui-plus/src/components/search-bar/complex-components/FuComplexDateTime.vue"]]);
FuSearchBar.install = (app) => {
  app.component(FuQuickSearch.name, FuQuickSearch);
  app.component(FuSearchBar.name, FuSearchBar);
  app.component(FuSearchBarButton.name, FuSearchBarButton);
  app.component(FuComplexSelect.name, FuComplexSelect);
  app.component(FuComplexInput.name, FuComplexInput);
  app.component(FuComplexDate.name, FuComplexDate);
  app.component(FuComplexDateTime.name, FuComplexDateTime);
};
var __glob_2_3 = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  "default": FuSearchBar
}, Symbol.toStringTag, { value: "Module" }));
var _a;
const isClient = typeof window !== "undefined";
isClient && ((_a = window == null ? void 0 : window.navigator) == null ? void 0 : _a.userAgent) && /iP(ad|hone|od)/.test(window.navigator.userAgent);
Object.freeze({});
Object.freeze([]);
const isArray = Array.isArray;
const isElement = (e) => {
  if (typeof Element === "undefined")
    return false;
  return e instanceof Element;
};
const nodeList = /* @__PURE__ */ new Map();
let startClick;
if (isClient) {
  document.addEventListener("mousedown", (e) => startClick = e);
  document.addEventListener("mouseup", (e) => {
    for (const handlers of nodeList.values()) {
      for (const { documentHandler } of handlers) {
        documentHandler(e, startClick);
      }
    }
  });
}
function createDocumentHandler(el, binding) {
  let excludes = [];
  if (Array.isArray(binding.arg)) {
    excludes = binding.arg;
  } else if (isElement(binding.arg)) {
    excludes.push(binding.arg);
  }
  return function(mouseup, mousedown) {
    const popperRef = binding.instance.popperRef;
    const mouseUpTarget = mouseup.target;
    const mouseDownTarget = mousedown == null ? void 0 : mousedown.target;
    const isBound = !binding || !binding.instance;
    const isTargetExists = !mouseUpTarget || !mouseDownTarget;
    const isContainedByEl = el.contains(mouseUpTarget) || el.contains(mouseDownTarget);
    const isSelf = el === mouseUpTarget;
    const isTargetExcluded = excludes.length && excludes.some((item) => item == null ? void 0 : item.contains(mouseUpTarget)) || excludes.length && excludes.includes(mouseDownTarget);
    const isContainedByPopper = popperRef && (popperRef.contains(mouseUpTarget) || popperRef.contains(mouseDownTarget));
    if (isBound || isTargetExists || isContainedByEl || isSelf || isTargetExcluded || isContainedByPopper) {
      return;
    }
    binding.value(mouseup, mousedown);
  };
}
const ClickOutside = {
  beforeMount(el, binding) {
    if (!nodeList.has(el)) {
      nodeList.set(el, []);
    }
    nodeList.get(el).push({
      documentHandler: createDocumentHandler(el, binding),
      bindingFn: binding.value
    });
  },
  updated(el, binding) {
    if (!nodeList.has(el)) {
      nodeList.set(el, []);
    }
    const handlers = nodeList.get(el);
    const oldHandlerIndex = handlers.findIndex((item) => item.bindingFn === binding.oldValue);
    const newHandler = {
      documentHandler: createDocumentHandler(el, binding),
      bindingFn: binding.value
    };
    if (oldHandlerIndex >= 0) {
      handlers.splice(oldHandlerIndex, 1, newHandler);
    } else {
      handlers.push(newHandler);
    }
  },
  unmounted(el) {
    nodeList.delete(el);
  }
};
const _sfc_main$l = /* @__PURE__ */ defineComponent({
  __name: "FuSpeedDialButton",
  props: {
    type: {
      type: String,
      default: "default",
      validator: validateType
    },
    rotate: Boolean,
    disabled: Boolean,
    active: Boolean,
    icon: String,
    size: {
      type: String,
      default: "32px"
    },
    backgroundColor: String,
    color: String,
    fontSize: String
  },
  setup(__props) {
    return (_ctx, _cache) => {
      const _component_el_icon = resolveComponent("el-icon");
      return openBlock(), createElementBlock("div", {
        class: normalizeClass([
          "fu-speed-dial-button",
          "el-button",
          "el-button--" + __props.type,
          {
            "fu-speed-dial-button--rotate": __props.rotate,
            "is-disabled": __props.disabled,
            "is-active": __props.active
          }
        ]),
        style: normalizeStyle({
          width: __props.size,
          height: __props.size,
          backgroundColor: __props.backgroundColor,
          color: __props.color,
          fontSize: __props.fontSize
        })
      }, [
        renderSlot(_ctx.$slots, "default", {}, () => [
          createVNode(_component_el_icon, null, {
            default: withCtx(() => [
              (openBlock(), createBlock(resolveDynamicComponent(__props.icon)))
            ]),
            _: 1
          })
        ])
      ], 6);
    };
  }
});
var FuSpeedDialButton = /* @__PURE__ */ _export_sfc(_sfc_main$l, [["__file", "/Users/runner/work/fit2cloud-ui-plus/fit2cloud-ui-plus/src/components/speed-dial/FuSpeedDialButton.vue"]]);
const SpeedDialKey = Symbol("SpeedDialKey");
const _hoisted_1$6 = { class: "fu-speed-dial-action-button" };
const _sfc_main$k = /* @__PURE__ */ defineComponent({
  __name: "FuSpeedDialActionButton",
  props: {
    index: Number,
    icon: {
      type: String,
      default: "Plus"
    },
    titleClass: String,
    titleBgColor: String,
    titleColor: String,
    buttonClass: String,
    bgColor: String,
    color: String,
    title: [String, Number]
  },
  emits: ["click"],
  setup(__props, { emit }) {
    const props = __props;
    const speedDialKey = inject(SpeedDialKey);
    const config = computed(() => {
      return speedDialKey == null ? void 0 : speedDialKey.config;
    });
    const direction = computed(() => {
      return (speedDialKey == null ? void 0 : speedDialKey.direction.value) || "";
    });
    const titleSize = computed(() => {
      var _a2;
      let size = ((_a2 = config.value) == null ? void 0 : _a2.fab.size) + "px";
      let style = { position: "absolute", height: size };
      if (["top", "bottom"].includes(direction.value)) {
        style["text-align"] = "right";
        style["right"] = size;
      } else {
        style["text-align"] = "center";
        style["min-width"] = size;
        if (props.index || 0 % 2 === 0) {
          style.top = size;
        } else {
          style.top = "-" + size;
        }
      }
      return style;
    });
    const titleStyle = computed(() => {
      var _a2;
      let backgroundColor = props.titleBgColor;
      let color = props.titleColor;
      let fontSize = (_a2 = config.value) == null ? void 0 : _a2.item.titleFontSize;
      return { backgroundColor, color, fontSize };
    });
    const buttonProps = computed(() => {
      var _a2, _b;
      let backgroundColor = props.bgColor;
      let color = props.color;
      let fontSize = (_a2 = config.value) == null ? void 0 : _a2.item.buttonFontSize;
      let size = ((_b = config.value) == null ? void 0 : _b.item.size) + "px";
      return { backgroundColor, color, fontSize, size };
    });
    function click(e) {
      const { index, title } = props;
      emit("click", { index, title }, e);
      speedDialKey == null ? void 0 : speedDialKey.close();
    }
    return (_ctx, _cache) => {
      return openBlock(), createElementBlock("div", _hoisted_1$6, [
        __props.title ? (openBlock(), createElementBlock("div", {
          key: 0,
          class: "fu-speed-dial-action-button__title",
          style: normalizeStyle(unref(titleSize))
        }, [
          renderSlot(_ctx.$slots, "title", {}, () => [
            createElementVNode("div", {
              class: normalizeClass(["fu-speed-dial-action-button__text", __props.titleClass]),
              style: normalizeStyle(unref(titleStyle)),
              onClick: click
            }, toDisplayString(__props.title), 7)
          ])
        ], 4)) : createCommentVNode("v-if", true),
        renderSlot(_ctx.$slots, "default", {}, () => [
          createVNode(FuSpeedDialButton, mergeProps({ class: __props.buttonClass }, unref(buttonProps), {
            icon: __props.icon,
            onClick: click
          }), null, 16, ["class", "icon"])
        ])
      ]);
    };
  }
});
var FuSpeedDialActionButton = /* @__PURE__ */ _export_sfc(_sfc_main$k, [["__file", "/Users/runner/work/fit2cloud-ui-plus/fit2cloud-ui-plus/src/components/speed-dial/FuSpeedDialActionButton.vue"]]);
const __default__$a = { name: "FuSpeedDialItem" };
const _sfc_main$j = /* @__PURE__ */ defineComponent(__spreadProps(__spreadValues({}, __default__$a), {
  props: {
    index: {
      type: Number,
      required: true
    }
  },
  setup(__props) {
    const props = __props;
    const speedDialKey = inject(SpeedDialKey);
    const config = computed(() => {
      return speedDialKey == null ? void 0 : speedDialKey.config;
    });
    const direction = computed(() => {
      return (speedDialKey == null ? void 0 : speedDialKey.direction.value) || "";
    });
    const isActive = computed(() => {
      var _a2;
      return (_a2 = speedDialKey == null ? void 0 : speedDialKey.active) == null ? void 0 : _a2.value;
    });
    const spacing = computed(() => {
      return config.value.item.spacing || 0;
    });
    const directionPosition = computed(() => {
      var _a2, _b, _c, _d;
      if (["top", "left"].includes(direction.value)) {
        return -((_b = (_a2 = config.value) == null ? void 0 : _a2.fab) == null ? void 0 : _b.size) - spacing.value;
      }
      return ((_d = (_c = config.value) == null ? void 0 : _c.fab) == null ? void 0 : _d.size) + spacing.value;
    });
    const itemSize = computed(() => {
      var _a2, _b;
      let size = ((_b = (_a2 = config.value) == null ? void 0 : _a2.fab) == null ? void 0 : _b.size) + "px";
      return {
        width: size,
        height: size
      };
    });
    function setPosition(el, position) {
      if (["top", "bottom"].includes(direction.value)) {
        el.style.transform = "translateY(" + position + ")";
      } else {
        el.style.transform = "translateX(" + position + ")";
      }
    }
    function beforeEnter(el) {
      el.style.transition = "all 0.3s";
      el.style.position = "absolute";
      setPosition(el, 0);
      el.style.opacity = "0";
    }
    function enter(el, done) {
      let position = props.index * directionPosition.value + "px";
      setTimeout(() => {
        setPosition(el, position);
        el.style.opacity = "1";
        done();
      });
    }
    function leave(el, done) {
      setPosition(el, 0);
      el.style.opacity = "0";
      setTimeout(() => {
        done();
      }, 200);
    }
    return (_ctx, _cache) => {
      return openBlock(), createBlock(Transition, {
        css: false,
        onBeforeEnter: beforeEnter,
        onEnter: enter,
        onLeave: leave
      }, {
        default: withCtx(() => [
          unref(isActive) ? (openBlock(), createElementBlock("div", {
            key: 0,
            class: "fu-speed-dial-item",
            style: normalizeStyle(unref(itemSize))
          }, [
            renderSlot(_ctx.$slots, "default", {}, () => [
              createVNode(FuSpeedDialActionButton, mergeProps({ index: __props.index }, _ctx.$attrs), null, 16, ["index"])
            ])
          ], 4)) : createCommentVNode("v-if", true)
        ]),
        _: 3
      });
    };
  }
}));
var FuSpeedDialItem = /* @__PURE__ */ _export_sfc(_sfc_main$j, [["__file", "/Users/runner/work/fit2cloud-ui-plus/fit2cloud-ui-plus/src/components/speed-dial/FuSpeedDialItem.vue"]]);
const _hoisted_1$5 = { class: "fu-speed-dial__content" };
const __default__$9 = { name: "FuSpeedDial" };
const _sfc_main$i = /* @__PURE__ */ defineComponent(__spreadProps(__spreadValues({}, __default__$9), {
  props: {
    modelValue: Boolean,
    id: String,
    type: {
      type: String,
      default: "primary"
    },
    items: Array,
    size: {
      type: String,
      default: "default",
      validator: (value) => ["large", "default", "small"].includes(value)
    },
    direction: {
      type: String,
      default: "top",
      validator: (value) => ["top", "bottom", "left", "right"].includes(value)
    },
    icon: {
      type: String,
      default: "Plus"
    },
    activeIcon: {
      type: String,
      default: "Close"
    },
    movable: {
      type: Boolean,
      default: false
    },
    position: {
      type: String,
      validator: (value) => ["absolute", "fixed"].includes(value)
    },
    left: String,
    top: String,
    right: String,
    bottom: String,
    zIndex: {
      type: [String, Number],
      default: 99
    },
    itemClickClose: {
      type: Boolean,
      default: true
    },
    outsideClose: {
      type: Boolean,
      default: true
    },
    manual: {
      type: Boolean,
      default: false
    },
    localKey: String,
    sizeOptions: {
      type: Object,
      default: () => {
        return {
          large: {
            fab: { size: 56, fontSize: "18px" },
            item: { size: 40, spacing: 0, titleFontSize: "14px", buttonFontSize: "18px" }
          },
          default: {
            fab: { size: 40, fontSize: "16px" },
            item: { size: 32, spacing: 0, titleFontSize: "14px", buttonFontSize: "16px" }
          },
          small: {
            fab: { size: 32, fontSize: "12px", padding: 0 },
            item: { size: 24, spacing: 0, titleFontSize: "12px", buttonFontSize: "12px" }
          }
        };
      }
    }
  },
  emits: ["close", "outside-click", "click"],
  setup(__props, { expose, emit }) {
    const props = __props;
    const slots = useSlots();
    const instance = getCurrentInstance();
    const active = ref(false);
    const moving = ref(false);
    const { zIndex, position, left, top, right, bottom } = props;
    const style = ref({ zIndex, position, left, top, right, bottom });
    watch(() => props.modelValue, (v) => {
      active.value = v;
    });
    watch(() => props.position, () => updateStyle());
    watch(() => props.zIndex, () => updateStyle());
    watch(() => props.left, () => updateStyle());
    watch(() => props.right, () => updateStyle());
    watch(() => props.top, () => updateStyle());
    watch(() => props.bottom, () => updateStyle());
    function updateStyle() {
      const { zIndex: zIndex2, position: position2, left: left2, top: top2, right: right2, bottom: bottom2 } = props;
      style.value = { zIndex: zIndex2, position: position2, left: left2, top: top2, right: right2, bottom: bottom2 };
    }
    const saveKey = computed(() => {
      return "Fu-SD-" + props.localKey;
    });
    const hashChildren = computed(() => {
      if (props.items && props.items.length > 0) {
        return true;
      }
      return slots == null ? void 0 : slots.default;
    });
    const config = computed(() => {
      return props.sizeOptions[props.size] || props.sizeOptions["default"];
    });
    const buttonProps = computed(() => {
      let rotate = true;
      let size = config.value.fab.size + "px";
      let fontSize = config.value.fab.fontSize;
      let icon = props.activeIcon === props.icon ? props.icon : active.value ? props.activeIcon : props.icon;
      return { type: props.type, rotate, active: active.value, size, fontSize, icon };
    });
    const spacing = computed(() => {
      let spacing2 = config.value.item.spacing || 0;
      spacing2 += (config.value.fab.size - config.value.item.size) / 2;
      return spacing2;
    });
    const contentPosition = computed(() => {
      let position2 = config.value.fab.size + spacing.value;
      if (["top", "left"].includes(props.direction)) {
        position2 = -config.value.fab.size - spacing.value;
      }
      let positionStyle = { position: "absolute", zIndex: props.zIndex };
      if (["top", "bottom"].includes(props.direction)) {
        positionStyle.top = position2 + "px";
      } else {
        positionStyle.top = 0;
        positionStyle.left = position2 + "px";
      }
      return positionStyle;
    });
    function toggle(bool) {
      if (!moving.value && hashChildren.value) {
        active.value = bool === void 0 ? !active.value : bool;
      }
    }
    function outsideClickClose() {
      if (props.outsideClose && !props.manual) {
        toggle(false);
      }
      emit("outside-click", [props.id, active.value]);
    }
    function click(e) {
      if (!props.manual) {
        toggle();
      }
      emit("click", [props.id, active.value], e);
    }
    function mousedown() {
      if (props.movable) {
        document.addEventListener("mousemove", mousemove);
        document.addEventListener("mouseup", mouseup);
      }
    }
    function mousemove(e) {
      var _a2, _b;
      moving.value = true;
      if (props.position === "fixed") {
        const el = instance == null ? void 0 : instance.vnode.el;
        const rect = el.getBoundingClientRect();
        let left2 = e.clientX - rect.width / 2;
        let top2 = e.clientY - rect.height / 2;
        style.value.left = left2 + "px";
        style.value.top = top2 + "px";
        delete style.value.right;
        delete style.value.bottom;
      }
      if (props.position === "absolute") {
        const { offsetLeft, offsetTop, clientWidth, clientHeight, offsetParent } = instance == null ? void 0 : instance.vnode.el;
        const maxWidth = (_a2 = offsetParent == null ? void 0 : offsetParent.clientWidth) != null ? _a2 : 0 - clientWidth;
        const maxHeight = (_b = offsetParent == null ? void 0 : offsetParent.clientHeight) != null ? _b : 0 - clientHeight;
        let left2 = offsetLeft + e.movementX;
        let top2 = offsetTop + e.movementY;
        if (left2 > 0 && left2 < maxWidth) {
          style.value.left = left2 + "px";
          delete style.value.right;
        }
        if (top2 > 0 && top2 < maxHeight) {
          style.value.top = top2 + "px";
          delete style.value.bottom;
        }
      }
    }
    function mouseup() {
      writePosition();
      document.removeEventListener("mousemove", mousemove);
      document.removeEventListener("mouseup", mouseup);
      setTimeout(() => moving.value = false);
    }
    function writePosition() {
      if (props.localKey) {
        localStorage.setItem(saveKey.value, JSON.stringify(style.value));
      }
    }
    function readPosition() {
      let position2 = localStorage.getItem(saveKey.value);
      try {
        localStorage.getItem(saveKey.value);
        if (position2) {
          style.value = JSON.parse(position2);
        }
      } catch (e) {
        console.warn(saveKey.value + " error", e);
      }
    }
    function itemClick(index) {
      if (index !== void 0) {
        const item = props.items[index];
        if (item.click && typeof item.click === "function")
          return item.click(index);
      }
    }
    function close() {
      if (props.itemClickClose && !props.manual) {
        toggle(false);
      }
      emit("close", [props.id, active.value]);
    }
    provide(SpeedDialKey, {
      config: config.value,
      direction: computed(() => props.direction),
      active,
      close
    });
    onMounted(() => {
      readPosition();
    });
    expose({
      close
    });
    return (_ctx, _cache) => {
      return withDirectives((openBlock(), createElementBlock("div", {
        class: "fu-speed-dial",
        style: normalizeStyle(style.value)
      }, [
        createElementVNode("div", _hoisted_1$5, [
          renderSlot(_ctx.$slots, "fab", {}, () => [
            createVNode(FuSpeedDialButton, mergeProps(unref(buttonProps), {
              onClick: click,
              onMousedown: mousedown
            }), null, 16)
          ]),
          createElementVNode("div", {
            style: normalizeStyle(unref(contentPosition))
          }, [
            renderSlot(_ctx.$slots, "default", {}, () => [
              (openBlock(true), createElementBlock(Fragment, null, renderList(__props.items, (item, index) => {
                return openBlock(), createBlock(FuSpeedDialItem, mergeProps({
                  index,
                  key: index
                }, item, {
                  onClick: ($event) => itemClick(index)
                }), null, 16, ["index", "onClick"]);
              }), 128))
            ])
          ], 4)
        ])
      ], 4)), [
        [unref(ClickOutside), outsideClickClose]
      ]);
    };
  }
}));
var FuSpeedDial = /* @__PURE__ */ _export_sfc(_sfc_main$i, [["__file", "/Users/runner/work/fit2cloud-ui-plus/fit2cloud-ui-plus/src/components/speed-dial/FuSpeedDial.vue"]]);
FuSpeedDial.install = (app) => {
  app.component(FuSpeedDial.name, FuSpeedDial);
  app.component(FuSpeedDialItem.name, FuSpeedDialItem);
};
var __glob_2_4 = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  "default": FuSpeedDial
}, Symbol.toStringTag, { value: "Module" }));
const _hoisted_1$4 = {
  key: 0,
  class: "icon"
};
const __default__$8 = { name: "FuSplitPane" };
const _sfc_main$h = /* @__PURE__ */ defineComponent(__spreadProps(__spreadValues({}, __default__$8), {
  props: {
    min: {
      type: [Number, String],
      default: "10px"
    },
    left: [Number, String],
    right: [Number, String],
    top: [Number, String],
    bottom: [Number, String],
    direction: {
      validator: (val) => ["vertical", "horizontal"].includes(val),
      default: "horizontal"
    },
    localKey: String,
    resizable: {
      type: Boolean,
      default: true
    },
    resizerType: {
      validator: (val) => ["resizer", "line"].includes(val),
      default: "resizer"
    },
    resizerClass: String,
    resizerStyle: Object,
    resizerHoverClass: String
  },
  emits: ["changeSplit"],
  setup(__props, { emit }) {
    const props = __props;
    const instance = getCurrentInstance();
    const active = ref(false);
    const usedValue = ref(0);
    const oldValue = ref(0);
    const initOffset = ref(0);
    const hover = ref(false);
    watch(() => props.left, (newValue, oldValue2) => {
      if (newValue !== oldValue2) {
        nextTick(() => {
          usedValue.value = defaultValue.value;
        });
      }
    }, { immediate: true });
    watch(() => props.bottom, (newValue, oldValue2) => {
      if (newValue !== oldValue2) {
        nextTick(() => {
          usedValue.value = defaultValue.value;
        });
      }
    }, { immediate: true });
    const isReverse = computed(() => {
      return props.right || props.bottom;
    });
    const isHorizontal = computed(() => {
      return props.direction === "horizontal";
    });
    const userSelect = computed(() => {
      return active.value ? "none" : "";
    });
    const cursor = computed(() => {
      return active.value && props.resizable ? isHorizontal.value ? "col-resize" : "row-resize" : "";
    });
    const outerWrapperSize = computed(() => {
      return instance.refs.outerWrapper[offsetSize.value];
    });
    const offsetSize = computed(() => {
      return isHorizontal.value ? "offsetWidth" : "offsetHeight";
    });
    const defaultValue = computed(() => {
      if (isHorizontal.value) {
        return props.left ? getMin(percentToValue(props.left)) : props.right && getMin(percentToValue(props.right)) || outerWrapperSize.value / 2;
      } else {
        return props.top ? getMin(percentToValue(props.top)) : props.bottom && getMin(percentToValue(props.bottom)) || outerWrapperSize.value / 2;
      }
    });
    const valueAnother = computed(() => {
      return `calc(100% - ${usedValue.value}px)`;
    });
    const attr = computed(() => {
      return isHorizontal.value ? "width" : "height";
    });
    const resizerAttr = computed(() => {
      return isHorizontal.value ? isReverse.value ? "right" : "left" : isReverse.value ? "bottom" : "top";
    });
    const saveKey = computed(() => {
      return "Fu-SP-" + props.localKey;
    });
    const resizerClasses = computed(() => {
      const classes = [
        `fu-split-pane__${props.resizerType}`,
        `is-${props.direction}`,
        props.resizable && "is-resizable",
        props.resizerClass,
        hover.value && (props.resizerHoverClass || "hover")
      ];
      return classes;
    });
    const padding = computed(() => {
      return props.resizerType === "resizer" && isHorizontal.value && "3px";
    });
    function onMouseDown(e) {
      initOffset.value = isHorizontal.value ? e.pageX : e.pageY;
      oldValue.value = usedValue.value;
      active.value = true;
      document.addEventListener("mousemove", onMouseMove);
      document.addEventListener("mouseup", onMouseUp);
    }
    function onMouseUp() {
      active.value = false;
      document.removeEventListener("mousemove", onMouseMove);
      document.removeEventListener("mouseup", onMouseUp);
      emit("changeSplit", usedValue.value);
    }
    function onMouseMove(e) {
      if (!props.resizable)
        return;
      if (active.value) {
        const currentPage = isHorizontal.value ? e.pageX : e.pageY;
        const offset = currentPage - initOffset.value;
        const value = isReverse.value ? oldValue.value - offset : oldValue.value + offset;
        if (value > percentToValue(props.min) && value < outerWrapperSize.value - percentToValue(props.min)) {
          usedValue.value = value;
          writeValue();
        }
      }
    }
    function percentToValue(val) {
      const size = instance.refs.outerWrapper[offsetSize.value];
      if (typeof val === "string" && val.includes("%")) {
        return parseInt(val) / 100 * size;
      } else {
        return parseInt(val);
      }
    }
    function getMin(val) {
      return val < percentToValue(props.min) ? percentToValue(props.min) : val;
    }
    function writeValue() {
      const obj = {
        [resizerAttr.value]: usedValue.value
      };
      if (props.localKey) {
        localStorage.setItem(saveKey.value, JSON.stringify(obj));
      }
    }
    function readValue() {
      if (props.localKey) {
        const local = localStorage.getItem(saveKey.value);
        if (local && local[resizerAttr.value]) {
          usedValue.value = parseInt(local) || defaultValue.value;
        } else {
          usedValue.value = defaultValue.value;
        }
      } else {
        usedValue.value = defaultValue.value;
      }
    }
    onMounted(() => {
      readValue();
    });
    return (_ctx, _cache) => {
      const _component_MoreFilled = resolveComponent("MoreFilled");
      const _component_el_icon = resolveComponent("el-icon");
      return openBlock(), createElementBlock("div", {
        style: normalizeStyle({ cursor: unref(cursor), userSelect: unref(userSelect) }),
        class: "fu-split-pane",
        ref: "outerWrapper"
      }, [
        createElementVNode("div", {
          class: normalizeClass([`is-${__props.direction}`, "fu-split-pane__left"]),
          style: normalizeStyle({ [unref(attr)]: unref(isReverse) ? unref(valueAnother) : `${usedValue.value}px`, "padding-right": unref(padding) })
        }, [
          renderSlot(_ctx.$slots, unref(isHorizontal) ? "left" : "top")
        ], 6),
        createElementVNode("div", {
          class: normalizeClass(unref(resizerClasses)),
          style: normalizeStyle(__spreadValues({ [unref(resizerAttr)]: `${usedValue.value}px` }, __props.resizerStyle)),
          onMousedown: onMouseDown,
          onMouseover: _cache[0] || (_cache[0] = ($event) => hover.value = true),
          onMouseleave: _cache[1] || (_cache[1] = ($event) => hover.value = false)
        }, [
          __props.resizerType === "resizer" ? (openBlock(), createElementBlock("div", _hoisted_1$4, [
            renderSlot(_ctx.$slots, "resizer", {}, () => [
              createVNode(_component_el_icon, { size: 10 }, {
                default: withCtx(() => [
                  createVNode(_component_MoreFilled)
                ]),
                _: 1
              })
            ])
          ])) : createCommentVNode("v-if", true)
        ], 38),
        createElementVNode("div", {
          class: normalizeClass([`is-${__props.direction}`, "fu-split-pane__right"]),
          style: normalizeStyle({ [unref(attr)]: unref(isReverse) ? `${usedValue.value}px` : unref(valueAnother), "padding-left": unref(padding) })
        }, [
          renderSlot(_ctx.$slots, unref(isHorizontal) ? "right" : "bottom")
        ], 6)
      ], 4);
    };
  }
}));
var FuSplitPane = /* @__PURE__ */ _export_sfc(_sfc_main$h, [["__file", "/Users/runner/work/fit2cloud-ui-plus/fit2cloud-ui-plus/src/components/split-pane/FuSplitPane.vue"]]);
FuSplitPane.install = (app) => {
  app.component(FuSplitPane.name, FuSplitPane);
};
var __glob_2_5 = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  "default": FuSplitPane
}, Symbol.toStringTag, { value: "Module" }));
const _sfc_main$g = /* @__PURE__ */ defineComponent({
  __name: "FuHorizontalNavigation",
  props: {
    stepper: Object,
    steps: Array,
    disable: Function
  },
  emits: ["active"],
  setup(__props, { emit }) {
    const props = __props;
    const active = computed(() => {
      return props.stepper.index;
    });
    function click(index) {
      !props.disable(index) && emit("active", index);
    }
    return (_ctx, _cache) => {
      const _component_el_step = resolveComponent("el-step");
      const _component_el_steps = resolveComponent("el-steps");
      return openBlock(), createBlock(_component_el_steps, mergeProps({ active: unref(active) }, __props.stepper), {
        default: withCtx(() => [
          (openBlock(true), createElementBlock(Fragment, null, renderList(__props.steps, (step, index) => {
            return openBlock(), createBlock(_component_el_step, mergeProps({ key: index }, step, {
              onClick: ($event) => click(index),
              class: __props.disable(index) && "fu-step--disable"
            }), null, 16, ["onClick", "class"]);
          }), 128))
        ]),
        _: 1
      }, 16, ["active"]);
    };
  }
});
var FuHorizontalNavigation = /* @__PURE__ */ _export_sfc(_sfc_main$g, [["__file", "/Users/runner/work/fit2cloud-ui-plus/fit2cloud-ui-plus/src/components/steps/FuHorizontalNavigation.vue"]]);
const _sfc_main$f = {};
function _sfc_render(_ctx, _cache) {
  const _component_el_button = resolveComponent("el-button");
  return openBlock(), createBlock(_component_el_button, normalizeProps(guardReactiveProps(_ctx.$attrs)), {
    default: withCtx(() => [
      renderSlot(_ctx.$slots, "default")
    ]),
    _: 3
  }, 16);
}
var FuStepButton = /* @__PURE__ */ _export_sfc(_sfc_main$f, [["render", _sfc_render], ["__file", "/Users/runner/work/fit2cloud-ui-plus/fit2cloud-ui-plus/src/components/steps/FuStepButton.vue"]]);
var FuStepsFooter = defineComponent({
  name: "FuStepsFooter",
  components: {
    FuStepButton
  },
  emits: ["stepperFn"],
  setup(props, { emit }) {
    const stepper = inject("stepper");
    const disabledButton = ref(false);
    const isFirst = computed(() => {
      return stepper.isFirst(stepper.index);
    });
    const isLast = computed(() => {
      return stepper.isLast(stepper.index);
    });
    const showCancel = computed(() => {
      return stepper.showCancel !== false;
    });
    const disabled = computed(() => {
      return (stepper == null ? void 0 : stepper.isLoading) || disabledButton.value;
    });
    function clickHandle(fnName) {
      stepper[fnName] ? stepper[fnName]() : emit("stepperFn", fnName);
      disabledButton.value = true;
      setTimeout(() => {
        disabledButton.value = false;
      }, 500);
    }
    const button = (value) => {
      return h(FuStepButton, {
        disabled: disabled.value,
        size: stepper.buttonSize,
        onClick: () => clickHandle(value)
      }, () => stepper[`${value}ButtonText`]);
    };
    return () => h("div", {
      class: `fu-steps__footer--${stepper.footerAlign}`
    }, [
      h("div", {
        class: "fu-steps__footer--block",
        style: "margin-right:10px"
      }, [showCancel.value && button("onCancel")]),
      h("div", {
        class: "fu-steps__footer--block"
      }, [
        !isFirst.value && button("prev"),
        isLast.value ? button("onFinish") : button("next")
      ])
    ]);
  }
});
const { t } = useLocale();
class Stepper {
  constructor(options) {
    __publicField(this, "steps");
    __publicField(this, "index");
    __publicField(this, "activeSet");
    __publicField(this, "isLoading");
    __publicField(this, "onCancelButtonText");
    __publicField(this, "onFinishButtonText");
    __publicField(this, "prevButtonText");
    __publicField(this, "nextButtonText");
    __publicField(this, "buttonSize");
    __publicField(this, "footerAlign");
    __publicField(this, "showCancel");
    __publicField(this, "beforeActive");
    __publicField(this, "beforeLeave");
    __publicField(this, "height");
    var _a2, _b, _c, _d, _e, _f, _g, _h, _i;
    options != null ? options : options = {};
    this.steps = options.steps;
    this.index = (_a2 = options.index) != null ? _a2 : 0;
    this.activeSet = /* @__PURE__ */ new Set();
    this.isLoading = (_b = options.isLoading) != null ? _b : false;
    this.onCancelButtonText = (_c = options.onCancelButtonText) != null ? _c : t("fu.steps.cancel");
    this.onFinishButtonText = (_d = options.onFinishButtonText) != null ? _d : t("fu.steps.finish");
    this.prevButtonText = (_e = options.prevButtonText) != null ? _e : t("fu.steps.prev");
    this.nextButtonText = (_f = options.nextButtonText) != null ? _f : t("fu.steps.next");
    this.buttonSize = (_g = options.buttonSize) != null ? _g : "default";
    this.footerAlign = (_h = options.footerAlign) != null ? _h : "flex";
    this.showCancel = (_i = options.showCancel) != null ? _i : false;
    this.beforeActive = options.beforeActive;
    this.beforeLeave = options.beforeLeave;
    this.height = options.height;
  }
  isFirst(index) {
    return index === 0;
  }
  isLast(index) {
    return index === this.steps.length - 1;
  }
  isActive(index) {
    return this.activeSet.has(index);
  }
  isCurrent(index) {
    return this.index === index;
  }
  async active(index) {
    const isValid = index >= 0 && index < this.steps.length && this.index !== index;
    const forward = index > this.index;
    if (isValid) {
      if (await this.executeBeforeLeave(this.index, forward) !== false) {
        if (await this.executeBeforeActive(index, forward) !== false) {
          this.index = index;
          this.activeSet.add(index);
        }
      }
    }
  }
  next() {
    if (!this.isLast(this.index)) {
      this.active(this.index + 1);
    }
  }
  prev() {
    if (!this.isFirst(this.index)) {
      this.active(this.index - 1);
    }
  }
  getStep(index) {
    if (this.steps && this.steps.length > index) {
      return this.steps[index];
    }
  }
  executeBeforeLeave(index, forward) {
    const step = this.getStep(index);
    if (step.beforeLeave) {
      return step.beforeLeave(step, forward);
    }
    if (this.beforeLeave) {
      return this.beforeLeave(step, forward);
    }
  }
  executeBeforeActive(index, forward) {
    const step = this.getStep(index);
    if (step.beforeActive) {
      return step.beforeActive(step, forward);
    }
    if (this.beforeActive) {
      return this.beforeActive(step, forward);
    }
  }
}
class Step {
  constructor(options) {
    __publicField(this, "id");
    __publicField(this, "index");
    __publicField(this, "beforeActive");
    __publicField(this, "beforeLeave");
    __publicField(this, "title");
    __publicField(this, "description");
    __publicField(this, "icon");
    __publicField(this, "status");
    options != null ? options : options = {};
    this.id = options.id;
    this.index = options.index;
    this.beforeActive = options.beforeActive;
    this.beforeLeave = options.beforeLeave;
    this.title = options.title;
    this.description = options.description;
    this.icon = options.icon;
    this.status = options.status;
  }
}
const _sfc_main$e = defineComponent({
  name: "FuHorizontalSteps",
  components: {
    FuHorizontalNavigation,
    FuStepsFooter
  },
  emits: ["change"],
  setup(_, { attrs, slots, emit, expose }) {
    var _a2;
    const stepper = ref(new Stepper());
    (_a2 = stepper.value) == null ? void 0 : _a2.activeSet.add(0);
    watch(() => stepper.value.index, (value) => {
      emit("change", stepper.value.steps[value]);
    });
    const heightStyle = computed(() => {
      var _a3;
      return { height: parseInt((_a3 = stepper.value) == null ? void 0 : _a3.height) + "px" || "auto" };
    });
    function active(index) {
      var _a3;
      (_a3 = stepper.value) == null ? void 0 : _a3.active(index);
    }
    function disable(index) {
      var _a3;
      return !((_a3 = stepper.value) == null ? void 0 : _a3.isActive(index));
    }
    function next() {
      stepper.value.next();
    }
    function prev() {
      stepper.value.prev();
    }
    function $func(name2) {
      emit(name2);
    }
    provide("stepper", stepper.value);
    expose({
      next,
      prev,
      active
    });
    return () => {
      var _a3, _b, _c;
      let steps = [];
      if ((_a3 = slots.default) == null ? void 0 : _a3.call(slots)) {
        (_b = slots.default) == null ? void 0 : _b.call(slots).forEach((node, index) => {
          const options = __spreadValues({
            index
          }, node.props);
          const step = new Step(options);
          steps.push(step);
        });
      }
      stepper.value.steps = steps;
      stepper.value = Object.assign(stepper.value, attrs);
      return h("div", {
        class: ["fu-steps", "fu-steps--horizontal"]
      }, [
        h(FuHorizontalNavigation, {
          stepper: stepper.value,
          steps,
          disable,
          onActive: active
        }),
        h("div", { class: "fu-steps__wrapper" }, h("div", { class: "fu-steps__container", style: heightStyle.value }, h(Transition, { name: "carousel", mode: "out-in", tag: "p" }, () => {
          var _a4;
          return (_a4 = slots.default) == null ? void 0 : _a4.call(slots).map((item, index) => {
            item["key"] = index;
            return stepper.value.index === index && item;
          });
        }))),
        h("div", { class: "fu-steps__footer" }, ((_c = slots.footer) == null ? void 0 : _c.call(slots)) || h(FuStepsFooter, { onStepperFn: $func }))
      ]);
    };
  }
});
var FuHorizontalSteps = /* @__PURE__ */ _export_sfc(_sfc_main$e, [["__file", "/Users/runner/work/fit2cloud-ui-plus/fit2cloud-ui-plus/src/components/steps/FuHorizontalSteps.vue"]]);
const _sfc_main$d = /* @__PURE__ */ defineComponent({
  __name: "FuVerticalNavigation",
  props: {
    stepper: Object,
    steps: Array,
    disable: Function
  },
  emits: ["active"],
  setup(__props, { emit }) {
    const props = __props;
    const active = computed(() => {
      return props.stepper.index;
    });
    const heightStyle = computed(() => {
      var _a2;
      return {
        height: parseInt((_a2 = props.stepper) == null ? void 0 : _a2.height) + "px" || "auto"
      };
    });
    function click(index) {
      !props.disable(index) && emit("active", index);
    }
    return (_ctx, _cache) => {
      const _component_el_collapse_transition = resolveComponent("el-collapse-transition");
      const _component_el_step = resolveComponent("el-step");
      const _component_el_steps = resolveComponent("el-steps");
      return openBlock(), createBlock(_component_el_steps, mergeProps({ active: unref(active) }, __props.stepper, { direction: "vertical" }), {
        default: withCtx(() => [
          (openBlock(true), createElementBlock(Fragment, null, renderList(__props.steps, (step, i) => {
            return openBlock(), createBlock(_component_el_step, mergeProps({ key: i }, step, {
              onClick: ($event) => click(i),
              class: __props.disable(i) && "fu-step--disable"
            }), {
              description: withCtx(() => [
                createElementVNode("span", null, toDisplayString(step.description), 1),
                createVNode(_component_el_collapse_transition, null, {
                  default: withCtx(() => [
                    i === unref(active) ? (openBlock(), createElementBlock("div", {
                      key: 0,
                      class: "fu-steps__container",
                      style: normalizeStyle(unref(heightStyle))
                    }, [
                      renderSlot(_ctx.$slots, "default", { step })
                    ], 4)) : createCommentVNode("v-if", true)
                  ]),
                  _: 2
                }, 1024)
              ]),
              _: 2
            }, 1040, ["onClick", "class"]);
          }), 128))
        ]),
        _: 3
      }, 16, ["active"]);
    };
  }
});
var FuVerticalNavigation = /* @__PURE__ */ _export_sfc(_sfc_main$d, [["__file", "/Users/runner/work/fit2cloud-ui-plus/fit2cloud-ui-plus/src/components/steps/FuVerticalNavigation.vue"]]);
const _sfc_main$c = defineComponent({
  name: "FuVerticalSteps",
  components: { FuVerticalNavigation, FuStepsFooter },
  emits: ["change"],
  setup(_, { attrs, slots, emit, expose }) {
    const stepper = ref(new Stepper());
    stepper.value.activeSet.add(0);
    watch(() => stepper.value.index, (value) => {
      emit("change", stepper.value.steps[value]);
    });
    function active(index) {
      stepper.value.active(index);
    }
    function disable(index) {
      return !stepper.value.isActive(index);
    }
    function next() {
      stepper.value.next();
    }
    function prev() {
      stepper.value.prev();
    }
    function $func(name2) {
      emit(name2);
    }
    provide("stepper", stepper.value);
    expose({
      next,
      prev,
      active
    });
    return () => {
      var _a2, _b;
      let currentNode;
      let steps = [];
      if ((_a2 = slots.default) == null ? void 0 : _a2.call(slots)) {
        (_b = slots.default) == null ? void 0 : _b.call(slots).forEach((node, index) => {
          const options = __spreadValues({
            index
          }, node.props);
          const step = new Step(options);
          steps.push(step);
          if (stepper.value.isCurrent(index)) {
            currentNode = node;
          }
        });
      }
      stepper.value.steps = steps;
      stepper.value = Object.assign(stepper.value, attrs);
      return h("div", {
        class: ["fu-steps", "fu-steps--vertical"]
      }, [
        h(FuVerticalNavigation, {
          stepper: stepper.value,
          steps,
          disable,
          onActive: active
        }, () => currentNode),
        h("div", { class: "fu-steps__footer" }, h(FuStepsFooter, { onStepperFn: $func }))
      ]);
    };
  }
});
var FuVerticalSteps = /* @__PURE__ */ _export_sfc(_sfc_main$c, [["__file", "/Users/runner/work/fit2cloud-ui-plus/fit2cloud-ui-plus/src/components/steps/FuVerticalSteps.vue"]]);
const _sfc_main$b = defineComponent({
  name: "FuSteps",
  components: {
    FuHorizontalSteps,
    FuVerticalSteps
  },
  emits: ["change"],
  props: ["direction"],
  setup(props, { attrs, slots, emit, expose }) {
    const { direction } = props;
    const FuSteps2 = ref();
    function next() {
      var _a2;
      (_a2 = FuSteps2.value) == null ? void 0 : _a2.next();
    }
    function prev() {
      var _a2;
      (_a2 = FuSteps2.value) == null ? void 0 : _a2.prev();
    }
    function active(index) {
      var _a2;
      (_a2 = FuSteps2.value) == null ? void 0 : _a2.active(index);
    }
    function handleChange({ id, title, index }) {
      emit("change", { id, title, index });
    }
    expose({
      next,
      prev,
      active
    });
    if (direction === "vertical") {
      return () => h(FuVerticalSteps, __spreadValues({ ref: FuSteps2, onChange: handleChange }, attrs), slots);
    } else {
      return () => h(FuHorizontalSteps, __spreadValues({ ref: FuSteps2, onChange: handleChange }, attrs), slots);
    }
  }
});
var FuSteps = /* @__PURE__ */ _export_sfc(_sfc_main$b, [["__file", "/Users/runner/work/fit2cloud-ui-plus/fit2cloud-ui-plus/src/components/steps/FuSteps.vue"]]);
const _hoisted_1$3 = { class: "fu-step" };
const __default__$7 = { name: "FuStep" };
const _sfc_main$a = /* @__PURE__ */ defineComponent(__spreadProps(__spreadValues({}, __default__$7), {
  setup(__props) {
    const stepper = inject("stepper");
    const loading = computed(() => stepper.isLoading || false);
    return (_ctx, _cache) => {
      const _directive_loading = resolveDirective("loading");
      return withDirectives((openBlock(), createElementBlock("div", _hoisted_1$3, [
        renderSlot(_ctx.$slots, "default")
      ])), [
        [_directive_loading, unref(loading)]
      ]);
    };
  }
}));
var FuStep = /* @__PURE__ */ _export_sfc(_sfc_main$a, [["__file", "/Users/runner/work/fit2cloud-ui-plus/fit2cloud-ui-plus/src/components/steps/FuStep.vue"]]);
FuSteps.install = (app) => {
  app.component(FuStep.name, FuStep);
  app.component(FuSteps.name, FuSteps);
};
var __glob_2_6 = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  "default": FuSteps
}, Symbol.toStringTag, { value: "Module" }));
function isFragment(node) {
  return isVNode(node) && node.type === Fragment;
}
function isComment(node) {
  return isVNode(node) && node.type === Comment;
}
function isValidElementNode(node) {
  return isVNode(node) && !isFragment(node) && !isComment(node);
}
function isValidChildren(children) {
  return Array.isArray(children) ? isValidElementNode(children[0]) : false;
}
function getChildren(nodes, depth = 5) {
  let node = isArray(nodes) ? nodes[0] : nodes;
  if (isFragment(node)) {
    if (isValidChildren(node.children))
      return node.children;
    if (depth > 0) {
      return getChildren(node.children[0], depth - 1);
    }
  }
  if (isValidChildren(nodes))
    return nodes;
  return [];
}
const isFix = (node) => {
  const includeTag = node.type.name.indexOf("FuTableOperations") >= 0;
  const { fix, prop, type } = node.props;
  return prop === void 0 || fix !== void 0 && fix !== false || ["selection", "index", "expand"].includes(type) || includeTag;
};
const getLabel = (node) => {
  if (node.props.label)
    return node.props.label;
  return node.props.type || node.props.prop;
};
const getProp = (node) => {
  if (node.props.prop)
    return node.props.prop;
  return node.props.label;
};
const FuTableBody = (props, context) => {
  let slots = context.slots.default();
  const nodes = [];
  let { columns } = props;
  let children = getChildren(slots);
  if (!children)
    return nodes;
  if (!columns || (columns == null ? void 0 : columns.length) === 0)
    return children;
  columns.forEach((col) => {
    if (isArray(children)) {
      let node = children.find((child) => {
        const isColNode = col.prop === getProp(child) && child.type.name !== void 0;
        if (isColNode && child.props.label !== col.label && col.prop !== void 0) {
          col.label = child.props.label;
        }
        return isColNode;
      });
      if (node && (isFix(node) || col.show !== false)) {
        nodes.push(node);
      }
    }
  });
  return nodes;
};
const LocalKey = Symbol("LocalKey");
const __default__$6 = { name: "FuTable" };
const _sfc_main$9 = /* @__PURE__ */ defineComponent(__spreadProps(__spreadValues({}, __default__$6), {
  props: {
    columns: Array,
    refresh: {
      type: Boolean,
      default: true
    },
    localKey: String,
    refTable: String
  },
  setup(__props, { expose }) {
    var _a2, _b;
    const props = __props;
    const refElTable = ref(null);
    const slots = (_b = (_a2 = useSlots()).default) == null ? void 0 : _b.call(_a2);
    const key = ref(0);
    const prefix = "FU-T-";
    const cleanColumns = (columns) => {
      columns.splice(0, columns.length);
    };
    const updateNodes = (nodes) => {
      nodes.forEach((node) => {
        if (isValidElementNode(node) && !node.type.key) {
          node.type.key = getProp(node);
        }
      });
    };
    const initColumns = (nodes, columns) => {
      nodes.forEach((node) => {
        const label = getLabel(node);
        const prop = getProp(node);
        const fix = isFix(node);
        const { show } = node.props;
        if (!prop && !fix) {
          throw new Error("unfixed column's label is required.");
        }
        columns.push({ label, prop, show, fix });
      });
    };
    const copyColumns = (source, target) => {
      source.forEach((col) => {
        target.push(col);
      });
    };
    const updateColumns = (nodes, columns) => {
      if (columns === void 0)
        return;
      if (nodes.length !== columns.length) {
        cleanColumns(columns);
        initColumns(nodes, columns);
      }
      if (columns.some((col) => col.prop === void 0)) {
        columns.forEach((col, i) => {
          var _a3, _b2;
          (_a3 = col.prop) != null ? _a3 : col.prop = getProp(nodes[i]);
          (_b2 = col.label) != null ? _b2 : col.label = getLabel(nodes[i]);
        });
      }
    };
    const columnsKey = computed(() => {
      return prefix + props.localKey;
    });
    let children;
    if (slots) {
      if (isValidChildren(slots)) {
        children = slots;
      }
      children = getChildren(slots);
    }
    watch(() => props.columns, () => {
      if (props.refresh) {
        key.value++;
      }
      if (props.localKey) {
        localStorage.setItem(columnsKey.value, JSON.stringify(props.columns));
      }
    }, { deep: true });
    onMounted(() => {
      updateNodes(children);
      if (!children || !props.columns)
        return;
      if (props.localKey) {
        let str = localStorage.getItem(columnsKey.value);
        if (str) {
          try {
            const columns = JSON.parse(str);
            cleanColumns(props.columns);
            copyColumns(columns, props.columns);
            updateColumns(children, props.columns);
            return;
          } catch (e) {
            console.error("get columns error", e);
          }
        }
      }
      if (props.columns.length === 0) {
        initColumns(children, props.columns);
      }
    });
    provide(LocalKey, props.localKey);
    onUpdated(() => {
      updateNodes(children);
      updateColumns(children, props.columns);
    });
    expose({
      refElTable
    });
    return (_ctx, _cache) => {
      const _component_el_table = resolveComponent("el-table");
      return openBlock(), createBlock(_component_el_table, mergeProps({ class: "fu-table" }, _ctx.$attrs, {
        key: key.value,
        "header-row-class-name": "fu-table-header",
        ref_key: "refElTable",
        ref: refElTable
      }), {
        append: withCtx(() => [
          renderSlot(_ctx.$slots, "append")
        ]),
        empty: withCtx(() => [
          renderSlot(_ctx.$slots, "empty")
        ]),
        default: withCtx(() => [
          createVNode(unref(FuTableBody), {
            name: "table-body",
            columns: __props.columns
          }, {
            default: withCtx(() => [
              renderSlot(_ctx.$slots, "default")
            ]),
            _: 3
          }, 8, ["columns"])
        ]),
        _: 3
      }, 16);
    };
  }
}));
var FuTable = /* @__PURE__ */ _export_sfc(_sfc_main$9, [["__file", "/Users/runner/work/fit2cloud-ui-plus/fit2cloud-ui-plus/src/components/table/FuTable.vue"]]);
const tableColumnSelect = (localKey) => {
  const columnsKey = computed(() => {
    return localKey ? "FU-T-" + localKey : "";
  });
  function dragstart(event, index) {
    if (event.dataTransfer) {
      event.dataTransfer.effectAllowed = "move";
      event.dataTransfer.setData("source_index", index);
    }
  }
  function dragenter(event) {
    event.preventDefault();
    let target = event.target;
    if (target) {
      target.style.opacity = ".2";
    }
  }
  function dragleave(event) {
    event.preventDefault();
    let target = event.target;
    if (target) {
      target.style.opacity = "";
    }
  }
  function dragend(event) {
    if (event.dataTransfer) {
      event.dataTransfer.clearData();
    }
  }
  function drop(event, list, index) {
    var _a2;
    let target = event.target;
    let source_index = Number((_a2 = event.dataTransfer) == null ? void 0 : _a2.getData("source_index"));
    let target_index = index;
    if (target_index > source_index) {
      list.splice(target_index + 1, 0, list[source_index]);
      list.splice(source_index, 1);
    } else {
      list.splice(target_index, 0, list[source_index]);
      list.splice(source_index + 1, 1);
    }
    if (target) {
      target.style.opacity = "";
    }
  }
  return {
    columnsKey,
    dragstart,
    dragenter,
    dragleave,
    dragend,
    drop
  };
};
const _hoisted_1$2 = { class: "fu-table-column-select-popper__body" };
const _hoisted_2$1 = { class: "fu-table-column-select-popper__footer" };
const _sfc_main$8 = /* @__PURE__ */ defineComponent({
  __name: "FuTableColumnSelectPopover",
  props: {
    icon: {
      type: String,
      default: "Setting"
    },
    trigger: {
      type: String,
      default: "click",
      validator: (value) => ["click", "hover"].includes(value)
    },
    columns: {
      type: Array,
      default: () => []
    },
    popperClass: {
      type: String,
      default: ""
    },
    title: {
      type: String,
      default: ""
    }
  },
  setup(__props) {
    const props = __props;
    const { t: t2 } = useLocale();
    const localKey = inject(LocalKey, void 0);
    const {
      columnsKey,
      dragstart,
      dragenter,
      dragleave,
      dragend,
      drop
    } = tableColumnSelect(localKey);
    const isFixAll = computed(() => {
      var _a2;
      return (_a2 = props.columns) == null ? void 0 : _a2.every((c) => {
        return c.fix;
      });
    });
    const hasSelect = computed(() => {
      var _a2;
      return ((_a2 = props.columns) == null ? void 0 : _a2.length) > 0 && !isFixAll.value;
    });
    const header = computed(() => {
      return props.title || t2("fu.table.custom_table_fields");
    });
    function reset() {
      if (columnsKey) {
        localStorage.removeItem(columnsKey.value);
      }
      props.columns.splice(0, props.columns.length);
    }
    return (_ctx, _cache) => {
      const _component_el_checkbox = resolveComponent("el-checkbox");
      const _component_el_button = resolveComponent("el-button");
      const _component_el_popover = resolveComponent("el-popover");
      return openBlock(), createBlock(_component_el_popover, {
        class: "fu-table-column-select",
        "popper-class": __props.popperClass,
        trigger: __props.trigger,
        "show-arrow": false,
        style: normalizeStyle({ "visibility": unref(hasSelect) ? "visible" : "hidden" })
      }, {
        reference: withCtx(() => [
          createVNode(_component_el_button, {
            class: "fu-search-bar-button",
            icon: __props.icon
          }, {
            default: withCtx(() => [
              createTextVNode(toDisplayString(unref(t2)("fu.table.custom_table_rows")), 1)
            ]),
            _: 1
          }, 8, ["icon"])
        ]),
        default: withCtx(() => [
          createElementVNode("h3", null, toDisplayString(unref(header)), 1),
          createElementVNode("div", _hoisted_1$2, [
            (openBlock(true), createElementBlock(Fragment, null, renderList(__props.columns, (c, i) => {
              return openBlock(), createElementBlock("div", {
                key: i,
                class: "fu-table-column-select-popper__item"
              }, [
                withDirectives(createVNode(_component_el_checkbox, {
                  modelValue: c.show,
                  "onUpdate:modelValue": ($event) => c.show = $event,
                  checked: c.show !== false,
                  draggable: "true",
                  onDragstart: ($event) => unref(dragstart)($event, i),
                  onDragenter: unref(dragenter),
                  onDragleave: unref(dragleave),
                  onDragover: _cache[0] || (_cache[0] = withModifiers(() => {
                  }, ["prevent"])),
                  onDragend: unref(dragend),
                  onDrop: ($event) => unref(drop)($event, __props.columns, i)
                }, {
                  default: withCtx(() => [
                    createTextVNode(toDisplayString(c.label), 1)
                  ]),
                  _: 2
                }, 1032, ["modelValue", "onUpdate:modelValue", "checked", "onDragstart", "onDragenter", "onDragleave", "onDragend", "onDrop"]), [
                  [vShow, !c.fix]
                ])
              ]);
            }), 128))
          ]),
          createElementVNode("div", _hoisted_2$1, [
            unref(columnsKey) ? (openBlock(), createBlock(_component_el_button, {
              key: 0,
              onClick: reset
            }, {
              default: withCtx(() => [
                createTextVNode(toDisplayString(unref(t2)("fu.table.reset")), 1)
              ]),
              _: 1
            })) : createCommentVNode("v-if", true)
          ])
        ]),
        _: 1
      }, 8, ["popper-class", "trigger", "style"]);
    };
  }
});
var FuTableColumnSelectPopover = /* @__PURE__ */ _export_sfc(_sfc_main$8, [["__file", "/Users/runner/work/fit2cloud-ui-plus/fit2cloud-ui-plus/src/components/table/table-column-select/FuTableColumnSelectPopover.vue"]]);
const _hoisted_1$1 = { style: { "display": "inline-block" } };
const _sfc_main$7 = /* @__PURE__ */ defineComponent({
  __name: "FuTableColumnSelectDialog",
  props: {
    icon: {
      type: String,
      default: "Setting"
    },
    columns: {
      type: Array,
      default: () => []
    },
    title: {
      type: String,
      default: ""
    }
  },
  setup(__props) {
    const props = __props;
    const localKey = inject(LocalKey, void 0);
    const { t: t2 } = useLocale();
    const cloneColumn = (source, target) => {
      source.forEach((col) => {
        target.push(__spreadValues({}, col));
      });
      return target;
    };
    const {
      columnsKey,
      dragstart,
      dragenter,
      dragleave,
      dragend,
      drop
    } = tableColumnSelect(localKey);
    const cloneColumns = ref([]);
    const visible = ref(false);
    const header = computed(() => {
      return props.title || t2("fu.table.custom_table_fields");
    });
    function open() {
      cloneColumns.value = [];
      cloneColumn(props.columns, cloneColumns.value);
    }
    function ok() {
      props.columns.splice(0, props.columns.length);
      cloneColumns.value.forEach((c) => {
        props.columns.push(c);
      });
      visible.value = false;
    }
    function reset() {
      if (columnsKey.value) {
        localStorage.removeItem(columnsKey.value);
      }
      props.columns.splice(0, props.columns.length);
      visible.value = false;
    }
    return (_ctx, _cache) => {
      const _component_el_button = resolveComponent("el-button");
      const _component_el_alert = resolveComponent("el-alert");
      const _component_el_checkbox = resolveComponent("el-checkbox");
      const _component_el_dialog = resolveComponent("el-dialog");
      return openBlock(), createElementBlock("div", _hoisted_1$1, [
        createVNode(_component_el_button, {
          class: "fu-search-bar-button",
          icon: __props.icon,
          onClick: _cache[0] || (_cache[0] = ($event) => visible.value = true)
        }, {
          default: withCtx(() => [
            createTextVNode(toDisplayString(unref(t2)("fu.table.custom_table_rows")), 1)
          ]),
          _: 1
        }, 8, ["icon"]),
        createVNode(_component_el_dialog, {
          class: "fu-table-column-select-dialog",
          modelValue: visible.value,
          "onUpdate:modelValue": _cache[2] || (_cache[2] = ($event) => visible.value = $event),
          onOpen: open,
          "append-to-body": ""
        }, {
          header: withCtx(() => [
            createElementVNode("h3", null, toDisplayString(unref(header)), 1),
            createVNode(_component_el_alert, {
              title: unref(t2)("fu.table.custom_table_fields_desc"),
              type: "info",
              closable: false
            }, null, 8, ["title"])
          ]),
          footer: withCtx(() => [
            unref(columnsKey) ? (openBlock(), createBlock(_component_el_button, {
              key: 0,
              onClick: reset
            }, {
              default: withCtx(() => [
                createTextVNode(toDisplayString(unref(t2)("fu.table.reset")), 1)
              ]),
              _: 1
            })) : createCommentVNode("v-if", true),
            createVNode(_component_el_button, {
              type: "primary",
              onClick: ok
            }, {
              default: withCtx(() => [
                createTextVNode(toDisplayString(unref(t2)("fu.table.ok")), 1)
              ]),
              _: 1
            })
          ]),
          default: withCtx(() => [
            (openBlock(true), createElementBlock(Fragment, null, renderList(unref(cloneColumns), (c, i) => {
              return withDirectives((openBlock(), createBlock(_component_el_checkbox, {
                key: i,
                modelValue: c.show,
                "onUpdate:modelValue": ($event) => c.show = $event,
                checked: c.show !== false,
                draggable: "true",
                onDragstart: ($event) => unref(dragstart)($event, i),
                onDragenter: unref(dragenter),
                onDragleave: unref(dragleave),
                onDragover: _cache[1] || (_cache[1] = withModifiers(() => {
                }, ["prevent"])),
                onDragend: unref(dragend),
                onDrop: ($event) => unref(drop)($event, unref(cloneColumns), i)
              }, {
                default: withCtx(() => [
                  createTextVNode(toDisplayString(c.label), 1)
                ]),
                _: 2
              }, 1032, ["modelValue", "onUpdate:modelValue", "checked", "onDragstart", "onDragenter", "onDragleave", "onDragend", "onDrop"])), [
                [vShow, !c.fix]
              ]);
            }), 128))
          ]),
          _: 1
        }, 8, ["modelValue"])
      ]);
    };
  }
});
var FuTableColumnSelectDialog = /* @__PURE__ */ _export_sfc(_sfc_main$7, [["__file", "/Users/runner/work/fit2cloud-ui-plus/fit2cloud-ui-plus/src/components/table/table-column-select/FuTableColumnSelectDialog.vue"]]);
const _sfc_main$6 = defineComponent({
  name: "FuTableColumnSelect",
  props: ["type"],
  setup(props, context) {
    const { type } = props;
    return () => {
      if (type === "dialog") {
        return h(FuTableColumnSelectDialog, context.attrs, context.slots);
      } else {
        return h(FuTableColumnSelectPopover, context.attrs, context.slots);
      }
    };
  }
});
var FuTableColumnSelect = /* @__PURE__ */ _export_sfc(_sfc_main$6, [["__file", "/Users/runner/work/fit2cloud-ui-plus/fit2cloud-ui-plus/src/components/table/table-column-select/FuTableColumnSelect.vue"]]);
const __default__$5 = { name: "FuTablePagination" };
const _sfc_main$5 = /* @__PURE__ */ defineComponent(__spreadProps(__spreadValues({}, __default__$5), {
  props: {
    currentPage: {
      type: Number,
      default: 1
    },
    pageSize: {
      type: Number,
      default: 5
    },
    pageSizes: {
      type: Array,
      default: function() {
        return [5, 10, 20, 50, 100];
      }
    },
    total: {
      type: Number,
      default: 0
    }
  },
  emits: ["size-change", "current-change", "change", "update:pageSize", "update:currentPage"],
  setup(__props, { emit }) {
    function handleSizeChange(size) {
      emit("update:pageSize", size);
      emit("size-change");
      emit("change");
    }
    function handleCurrentChange(current) {
      emit("update:currentPage", current);
      emit("current-change");
      emit("change");
    }
    return (_ctx, _cache) => {
      const _component_el_pagination = resolveComponent("el-pagination");
      return openBlock(), createBlock(_component_el_pagination, {
        onSizeChange: handleSizeChange,
        onCurrentChange: handleCurrentChange,
        "current-page": __props.currentPage,
        "page-sizes": __props.pageSizes,
        "page-size": __props.pageSize,
        layout: "total, sizes, prev, pager, next, jumper",
        total: __props.total
      }, null, 8, ["current-page", "page-sizes", "page-size", "total"]);
    };
  }
}));
var FuTablePagination = /* @__PURE__ */ _export_sfc(_sfc_main$5, [["__file", "/Users/runner/work/fit2cloud-ui-plus/fit2cloud-ui-plus/src/components/table/FuTablePagination.vue"]]);
const __default__$4 = { name: "FuTableButton" };
const _sfc_main$4 = /* @__PURE__ */ defineComponent(__spreadProps(__spreadValues({}, __default__$4), {
  props: {
    label: String,
    disabled: Boolean,
    icon: Boolean
  },
  setup(__props) {
    return (_ctx, _cache) => {
      const _component_el_button = resolveComponent("el-button");
      const _component_el_tooltip = resolveComponent("el-tooltip");
      return openBlock(), createBlock(_component_el_tooltip, {
        content: __props.label,
        disabled: !__props.icon
      }, {
        default: withCtx(() => [
          createVNode(_component_el_button, mergeProps({ link: "" }, _ctx.$attrs, { disabled: __props.disabled }), {
            default: withCtx(() => [
              renderSlot(_ctx.$slots, "default")
            ]),
            _: 3
          }, 16, ["disabled"])
        ]),
        _: 3
      }, 8, ["content", "disabled"]);
    };
  }
}));
var FuTableButton = /* @__PURE__ */ _export_sfc(_sfc_main$4, [["__file", "/Users/runner/work/fit2cloud-ui-plus/fit2cloud-ui-plus/src/components/table/table-operations/FuTableButton.vue"]]);
const __default__$3 = { name: "FuTableMoreButton" };
const _sfc_main$3 = /* @__PURE__ */ defineComponent(__spreadProps(__spreadValues({}, __default__$3), {
  props: {
    row: Object,
    buttons: {
      type: Array,
      required: true
    },
    size: {
      type: String,
      default: "default"
    },
    type: {
      type: String,
      default: "label",
      validator: (value) => ["icon", "label"].includes(value)
    }
  },
  setup(__props) {
    const props = __props;
    const { t: t2 } = useLocale();
    const disabled = computed(() => {
      return function(btn) {
        return typeof btn.disabled === "function" ? btn.disabled(props.row) : btn.disabled;
      };
    });
    function handleCommand(btn) {
      btn.click(props.row);
    }
    return (_ctx, _cache) => {
      const _component_MoreFilled = resolveComponent("MoreFilled");
      const _component_el_icon = resolveComponent("el-icon");
      const _component_el_button = resolveComponent("el-button");
      const _component_el_dropdown_item = resolveComponent("el-dropdown-item");
      const _component_el_dropdown_menu = resolveComponent("el-dropdown-menu");
      const _component_el_dropdown = resolveComponent("el-dropdown");
      return openBlock(), createBlock(_component_el_dropdown, {
        onCommand: handleCommand,
        class: "fu-table-more-button"
      }, {
        dropdown: withCtx(() => [
          createVNode(_component_el_dropdown_menu, null, {
            default: withCtx(() => [
              (openBlock(true), createElementBlock(Fragment, null, renderList(__props.buttons, (btn, i) => {
                return openBlock(), createBlock(_component_el_dropdown_item, {
                  key: i,
                  icon: __props.type === "icon" ? btn.icon : "",
                  disabled: unref(disabled)(btn),
                  command: btn
                }, {
                  default: withCtx(() => [
                    createTextVNode(toDisplayString(btn.label), 1)
                  ]),
                  _: 2
                }, 1032, ["icon", "disabled", "command"]);
              }), 128))
            ]),
            _: 1
          })
        ]),
        default: withCtx(() => [
          createVNode(_component_el_button, {
            link: "",
            type: "primary",
            onClick: _cache[0] || (_cache[0] = withModifiers(() => {
            }, ["stop"]))
          }, {
            default: withCtx(() => [
              __props.type === "icon" ? (openBlock(), createBlock(_component_el_icon, { key: 0 }, {
                default: withCtx(() => [
                  createVNode(_component_MoreFilled)
                ]),
                _: 1
              })) : (openBlock(), createElementBlock(Fragment, { key: 1 }, [
                createTextVNode(toDisplayString(unref(t2)("fu.table.more")), 1)
              ], 64))
            ]),
            _: 1
          })
        ]),
        _: 1
      });
    };
  }
}));
var FuTableMoreButton = /* @__PURE__ */ _export_sfc(_sfc_main$3, [["__file", "/Users/runner/work/fit2cloud-ui-plus/fit2cloud-ui-plus/src/components/table/table-operations/FuTableMoreButton.vue"]]);
const __default__$2 = { name: "FuTableOperations" };
const _sfc_main$2 = /* @__PURE__ */ defineComponent(__spreadProps(__spreadValues({}, __default__$2), {
  props: {
    align: {
      type: String,
      default: "center"
    },
    width: [String, Number],
    minWidth: [String, Number],
    ellipsis: {
      type: Number,
      default: 2
    },
    buttons: {
      type: Array,
      required: true
    },
    type: {
      type: String,
      default: "label",
      validator: (value) => ["icon", "label"].includes(value)
    }
  },
  setup(__props) {
    const props = __props;
    const hasShowFunc = computed(() => {
      return props.buttons.some((btn) => typeof btn.show === "function");
    });
    const defaultButtons = computed(() => {
      return function(row) {
        return hasMore(row) ? showButtons(row).slice(0, props.ellipsis) : showButtons(row);
      };
    });
    const moreButtons = computed(() => {
      return function(row) {
        return hasMore(row) ? showButtons(row).slice(props.ellipsis) : [];
      };
    });
    const computeWidth = computed(() => {
      let length = hasShowFunc.value ? props.ellipsis : defaultButtons.value.length;
      let buttonsWidth = 35 + length * 58 + 58;
      if (props.minWidth) {
        buttonsWidth = buttonsWidth < props.minWidth ? props.minWidth : buttonsWidth;
      }
      return props.width ? props.width : buttonsWidth;
    });
    const disableButton = computed(() => {
      return function(btn, row) {
        return typeof btn.disabled === "function" ? btn.disabled(row) : btn.disabled;
      };
    });
    function showButtons(row) {
      var _a2;
      return (_a2 = props.buttons) == null ? void 0 : _a2.filter((btn) => typeof btn.show === "function" ? btn.show(row) !== false : btn.show !== false);
    }
    function hasMore(row) {
      var _a2;
      return ((_a2 = showButtons(row)) == null ? void 0 : _a2.length) > props.ellipsis + 1;
    }
    return (_ctx, _cache) => {
      const _component_el_icon = resolveComponent("el-icon");
      const _component_el_table_column = resolveComponent("el-table-column");
      return openBlock(), createBlock(_component_el_table_column, mergeProps({
        "class-name": "fu-table-operations",
        align: __props.align,
        width: unref(computeWidth)
      }, _ctx.$attrs), {
        header: withCtx(() => [
          createTextVNode(toDisplayString(_ctx.$attrs.label), 1)
        ]),
        default: withCtx(({ row }) => [
          (openBlock(true), createElementBlock(Fragment, null, renderList(unref(defaultButtons)(row), (btn, i) => {
            return openBlock(), createBlock(FuTableButton, {
              icon: __props.type === "icon",
              key: i,
              onClick: withModifiers(($event) => btn.click(row), ["stop"]),
              disabled: unref(disableButton)(btn, row),
              label: btn.label,
              type: btn.type || "primary",
              link: ""
            }, {
              default: withCtx(() => [
                __props.type === "icon" ? (openBlock(), createBlock(_component_el_icon, { key: 0 }, {
                  default: withCtx(() => [
                    (openBlock(), createBlock(resolveDynamicComponent(btn.icon)))
                  ]),
                  _: 2
                }, 1024)) : (openBlock(), createElementBlock(Fragment, { key: 1 }, [
                  createTextVNode(toDisplayString(btn.label), 1)
                ], 64))
              ]),
              _: 2
            }, 1032, ["icon", "onClick", "disabled", "label", "type"]);
          }), 128)),
          unref(moreButtons)(row).length > 0 ? (openBlock(), createBlock(FuTableMoreButton, {
            key: 0,
            type: __props.type,
            buttons: unref(moreButtons)(row),
            row
          }, null, 8, ["type", "buttons", "row"])) : createCommentVNode("v-if", true)
        ]),
        _: 1
      }, 16, ["align", "width"]);
    };
  }
}));
var FuTableOperations = /* @__PURE__ */ _export_sfc(_sfc_main$2, [["__file", "/Users/runner/work/fit2cloud-ui-plus/fit2cloud-ui-plus/src/components/table/table-operations/FuTableOperations.vue"]]);
const _hoisted_1 = { class: "fu-dropdown-link" };
const _hoisted_2 = {
  key: 0,
  class: "fu-table-column-dropdown__title"
};
const __default__$1 = { name: "FuTableColumnDropdown" };
const _sfc_main$1 = /* @__PURE__ */ defineComponent(__spreadProps(__spreadValues({}, __default__$1), {
  props: {
    showType: {
      type: String,
      default: "always",
      validator: (value) => ["always", "hover", "selected"].includes(value)
    },
    menus: {
      type: Array,
      default: () => []
    },
    title: String,
    trigger: {
      type: String,
      default: "click"
    },
    width: {
      type: String,
      default: "40"
    }
  },
  setup(__props, { expose }) {
    const props = __props;
    const instance = getCurrentInstance();
    const isShow = computed(() => {
      return function(row) {
        var _a2, _b, _c;
        if (props.showType === "selected") {
          const selection = (_c = (_b = (_a2 = instance == null ? void 0 : instance.parent) == null ? void 0 : _a2.parent) == null ? void 0 : _b.store) == null ? void 0 : _c.getSelectionRows();
          return selection.includes(row) && true;
        } else {
          return true;
        }
      };
    });
    const disabled = computed(() => {
      return function(item, row) {
        return typeof item.disabled === "function" ? item.disabled(row) : item.disabled;
      };
    });
    function handleCommand({ item, row }) {
      item.click(row);
    }
    function composeValue(item, row) {
      return {
        item,
        row
      };
    }
    function show(index) {
      instance.refs[`dropdown${index}`].handleOpen();
    }
    function hide(index) {
      instance.refs[`dropdown${index}`].handleClose();
    }
    expose({
      show,
      hide
    });
    return (_ctx, _cache) => {
      const _component_MoreFilled = resolveComponent("MoreFilled");
      const _component_el_icon = resolveComponent("el-icon");
      const _component_el_dropdown_item = resolveComponent("el-dropdown-item");
      const _component_el_dropdown_menu = resolveComponent("el-dropdown-menu");
      const _component_el_dropdown = resolveComponent("el-dropdown");
      const _component_el_table_column = resolveComponent("el-table-column");
      return openBlock(), createBlock(_component_el_table_column, mergeProps({
        "class-name": "fu-table-column-dropdown",
        width: __props.width,
        resizable: false,
        align: "center"
      }, _ctx.$attrs), {
        default: withCtx((scope) => [
          unref(isShow)(scope.row) ? (openBlock(), createBlock(_component_el_dropdown, {
            key: 0,
            onCommand: handleCommand,
            trigger: __props.trigger,
            class: normalizeClass(__props.showType === "hover" ? "fu-show-icon" : ""),
            placement: "bottom",
            ref: `dropdown${scope.$index}`
          }, {
            dropdown: withCtx(() => [
              createVNode(_component_el_dropdown_menu, null, {
                default: withCtx(() => [
                  renderSlot(_ctx.$slots, "title", {}, () => [
                    __props.title ? (openBlock(), createElementBlock("div", _hoisted_2, toDisplayString(__props.title), 1)) : createCommentVNode("v-if", true)
                  ]),
                  renderSlot(_ctx.$slots, "default", normalizeProps(guardReactiveProps(scope)), () => [
                    (openBlock(true), createElementBlock(Fragment, null, renderList(__props.menus, (item, i) => {
                      return openBlock(), createBlock(_component_el_dropdown_item, {
                        key: i,
                        icon: item.icon,
                        disabled: unref(disabled)(item, scope.row),
                        divided: item.divided,
                        command: composeValue(item, scope.row)
                      }, {
                        default: withCtx(() => [
                          createTextVNode(toDisplayString(item.label), 1)
                        ]),
                        _: 2
                      }, 1032, ["icon", "disabled", "divided", "command"]);
                    }), 128))
                  ])
                ]),
                _: 2
              }, 1024)
            ]),
            default: withCtx(() => [
              createElementVNode("span", _hoisted_1, [
                renderSlot(_ctx.$slots, "icon", {}, () => [
                  createVNode(_component_el_icon, { class: "fu-icon-more" }, {
                    default: withCtx(() => [
                      createVNode(_component_MoreFilled)
                    ]),
                    _: 1
                  })
                ])
              ])
            ]),
            _: 2
          }, 1032, ["trigger", "class"])) : createCommentVNode("v-if", true)
        ]),
        _: 3
      }, 16, ["width"]);
    };
  }
}));
var FuTableColumnDropdown = /* @__PURE__ */ _export_sfc(_sfc_main$1, [["__file", "/Users/runner/work/fit2cloud-ui-plus/fit2cloud-ui-plus/src/components/table/FuTableColumnDropdown.vue"]]);
FuTable.install = (app) => {
  app.component(FuTable.name, FuTable);
  app.component(FuTablePagination.name, FuTablePagination);
  app.component(FuTableColumnSelect.name, FuTableColumnSelect);
  app.component(FuTableColumnDropdown.name, FuTableColumnDropdown);
  app.component(FuTableOperations.name, FuTableOperations);
  app.component(FuTableButton.name, FuTableButton);
  app.component(FuTableMoreButton.name, FuTableMoreButton);
};
var __glob_2_7 = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  "default": FuTable
}, Symbol.toStringTag, { value: "Module" }));
const __default__ = { name: "FuTabs" };
const _sfc_main = /* @__PURE__ */ defineComponent(__spreadProps(__spreadValues({}, __default__), {
  props: {
    addType: {
      type: String,
      default: "default",
      validator: (val) => ["default", "dropdown"].includes(val)
    },
    dropdownMenus: {
      type: Array,
      default: () => []
    },
    addTrigger: {
      type: String,
      default: "hover",
      validator: (val) => ["hover", "click"].includes(val)
    },
    addIcon: {
      type: String,
      default: "Plus"
    },
    addButtonLabel: String,
    addable: Boolean
  },
  emits: ["command"],
  setup(__props, { emit }) {
    const props = __props;
    function handleCommand(e) {
      const name2 = v4();
      let obj = null;
      if (e) {
        obj = props.dropdownMenus.find((item) => item.command === e);
      }
      emit("command", name2, obj);
    }
    function beforeLeave(currentName, oldName) {
      if (currentName === "add") {
        return false;
      }
    }
    return (_ctx, _cache) => {
      const _component_el_icon = resolveComponent("el-icon");
      const _component_el_button = resolveComponent("el-button");
      const _component_el_dropdown_item = resolveComponent("el-dropdown-item");
      const _component_el_dropdown_menu = resolveComponent("el-dropdown-menu");
      const _component_el_dropdown = resolveComponent("el-dropdown");
      const _component_el_tab_pane = resolveComponent("el-tab-pane");
      const _component_el_tabs = resolveComponent("el-tabs");
      return openBlock(), createBlock(_component_el_tabs, mergeProps({
        class: "fu-tabs",
        "before-leave": beforeLeave,
        editable: false,
        addable: false
      }, _ctx.$attrs), {
        default: withCtx(() => [
          __props.addable ? (openBlock(), createBlock(_component_el_tab_pane, {
            name: "add",
            key: "add",
            lazy: true
          }, {
            label: withCtx(() => [
              renderSlot(_ctx.$slots, "add", {}, () => [
                createCommentVNode(" \u4E0B\u62C9\u65B9\u5F0F "),
                __props.addType === "dropdown" ? (openBlock(), createBlock(_component_el_dropdown, {
                  key: 0,
                  onCommand: handleCommand,
                  trigger: __props.addTrigger
                }, {
                  dropdown: withCtx(() => [
                    createVNode(_component_el_dropdown_menu, null, {
                      default: withCtx(() => [
                        (openBlock(true), createElementBlock(Fragment, null, renderList(__props.dropdownMenus, (item, i) => {
                          return openBlock(), createBlock(_component_el_dropdown_item, {
                            key: i,
                            icon: item.icon,
                            disabled: item.disabled,
                            divided: item.divided,
                            command: item.command
                          }, {
                            default: withCtx(() => [
                              createTextVNode(toDisplayString(item.label), 1)
                            ]),
                            _: 2
                          }, 1032, ["icon", "disabled", "divided", "command"]);
                        }), 128))
                      ]),
                      _: 1
                    })
                  ]),
                  default: withCtx(() => [
                    renderSlot(_ctx.$slots, "dropdownButton", {}, () => [
                      createVNode(_component_el_button, {
                        type: "primary",
                        plain: ""
                      }, {
                        default: withCtx(() => [
                          createVNode(_component_el_icon, null, {
                            default: withCtx(() => [
                              (openBlock(), createBlock(resolveDynamicComponent(__props.addIcon)))
                            ]),
                            _: 1
                          }),
                          __props.addButtonLabel ? (openBlock(), createElementBlock(Fragment, { key: 0 }, [
                            createTextVNode(toDisplayString(__props.addButtonLabel), 1)
                          ], 64)) : createCommentVNode("v-if", true)
                        ]),
                        _: 1
                      })
                    ])
                  ]),
                  _: 3
                }, 8, ["trigger"])) : (openBlock(), createElementBlock(Fragment, { key: 1 }, [
                  createCommentVNode(" \u9ED8\u8BA4 "),
                  createVNode(_component_el_button, {
                    onClick: handleCommand,
                    type: "primary",
                    plain: ""
                  }, {
                    default: withCtx(() => [
                      createVNode(_component_el_icon, null, {
                        default: withCtx(() => [
                          (openBlock(), createBlock(resolveDynamicComponent(__props.addIcon)))
                        ]),
                        _: 1
                      }),
                      __props.addButtonLabel ? (openBlock(), createElementBlock(Fragment, { key: 0 }, [
                        createTextVNode(toDisplayString(__props.addButtonLabel), 1)
                      ], 64)) : createCommentVNode("v-if", true)
                    ]),
                    _: 1
                  })
                ], 2112))
              ])
            ]),
            _: 3
          })) : createCommentVNode("v-if", true),
          renderSlot(_ctx.$slots, "default")
        ]),
        _: 3
      }, 16);
    };
  }
}));
var FuTabs = /* @__PURE__ */ _export_sfc(_sfc_main, [["__file", "/Users/runner/work/fit2cloud-ui-plus/fit2cloud-ui-plus/src/components/tabs/FuTabs.vue"]]);
FuTabs.install = (app) => {
  app.component(FuTabs.name, FuTabs);
};
var __glob_2_8 = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  "default": FuTabs
}, Symbol.toStringTag, { value: "Module" }));
const name = "fit2cloud-ui-plus";
const version = "1.1.4";
const main = "./lib/fit2cloud-ui-plus.es.js";
const files = [
  "lib",
  "src",
  "types"
];
const types = "./types/src/index.d.ts";
const author = "fit2cloud";
const license = "GPL-3.0 License";
const repository = {
  type: "git",
  url: "git+https://github.com/fit2cloud-ui/fit2cloud-ui-plus.git"
};
const scripts = {
  dev: "vite",
  build: "vite build",
  "build-lib": "vite build --mode lib && vue-tsc --emitDeclarationOnly",
  "build-docs": "vite build --mode docs",
  preview: "vite preview"
};
const dependencies = {
  "@element-plus/icons-vue": "^1.1.4",
  "element-plus": "^2.3.3",
  "github-markdown-css": "^5.1.0",
  "prism-theme-vars": "^0.2.3",
  prismjs: "^1.28.0",
  uuid: "^9.0.1",
  "vite-plugin-markdown": "^2.0.2",
  vue: "^3.2.37",
  "vue-clipboard3": "^2.0.0",
  "vue-router": "^4.0.14"
};
const devDependencies = {
  "@types/node": "^17.0.29",
  "@types/uuid": "^9.0.8",
  "@vitejs/plugin-vue": "^2.3.1",
  sass: "^1.51.0",
  "sass-loader": "^12.6.0",
  typescript: "^4.5.4",
  "unplugin-vue-define-options": "^0.6.1",
  vite: "^2.9.16",
  "vue-tsc": "^0.34.7"
};
var PackageJSON = {
  name,
  version,
  "private": false,
  main,
  files,
  types,
  author,
  license,
  repository,
  scripts,
  dependencies,
  devDependencies
};
const components = { "./components/filter-bar/index.ts": __glob_2_0, "./components/icon-button/index.ts": __glob_2_1, "./components/read-write-switch/index.ts": __glob_2_2, "./components/search-bar/index.ts": __glob_2_3, "./components/speed-dial/index.ts": __glob_2_4, "./components/split-pane/index.ts": __glob_2_5, "./components/steps/index.ts": __glob_2_6, "./components/table/index.ts": __glob_2_7, "./components/tabs/index.ts": __glob_2_8 };
const install = (app, config) => {
  Object.keys(components).forEach((key) => {
    let component = components[key].default;
    app.use(component);
  });
  provideGlobalConfig(config);
};
const plugin = {
  name: "Fit2CloudUIPlus",
  version: PackageJSON.version,
  install
};
export { plugin as default };
