/**
 * 说明文档
 * @name 表格名称
 * @header 表格头部参数,任意定义
 * @table table内容,字段要和header定义的属性保持一直
 * @children 多表使用
 */
export declare const attributes: ({
    name: string;
    header: {
        prop: string;
        desc: string;
        type: string;
        enum: string;
        default: string;
    };
    table: {
        prop: string;
        desc: string;
        type: string;
        enum: string;
        default: string;
    }[];
    children?: undefined;
} | {
    name: string;
    children: ({
        name: string;
        header: {
            prop: string;
            desc: string;
            type: string;
            enum: string;
            default: string;
            method?: undefined;
            value?: undefined;
        };
        table: {
            prop: string;
            desc: string;
            type: string;
            enum: string;
            default: string;
        }[];
    } | {
        name: string;
        header: {
            method: string;
            desc: string;
            value: string;
            prop?: undefined;
            type?: undefined;
            enum?: undefined;
            default?: undefined;
        };
        table: {
            method: string;
            desc: string;
            value: string;
        }[];
    })[];
    header?: undefined;
    table?: undefined;
} | {
    name: string;
    children: ({
        name: string;
        header: {
            prop: string;
            desc: string;
            type: string;
            enum: string;
            default: string;
            event?: undefined;
            value?: undefined;
            method?: undefined;
        };
        table: {
            prop: string;
            desc: string;
            type: string;
            enum: string;
            default: string;
        }[];
    } | {
        name: string;
        header: {
            event: string;
            desc: string;
            value: string;
            prop?: undefined;
            type?: undefined;
            enum?: undefined;
            default?: undefined;
            method?: undefined;
        };
        table: {
            event: string;
            desc: string;
            value: string;
        }[];
    } | {
        name: string;
        header: {
            method: string;
            desc: string;
            prop?: undefined;
            type?: undefined;
            enum?: undefined;
            default?: undefined;
            event?: undefined;
            value?: undefined;
        };
        table: {
            method: string;
            desc: string;
        }[];
    })[];
    header?: undefined;
    table?: undefined;
})[];
