import { PropType } from "vue";
import type { ZIndexProperty, PositionProperty } from 'csstype';
declare const _default: import("vue").DefineComponent<{
    modelValue: BooleanConstructor;
    id: StringConstructor;
    type: {
        type: StringConstructor;
        default: string;
    };
    items: any;
    size: {
        type: StringConstructor;
        default: string;
        validator: (value: string) => boolean;
    };
    direction: {
        type: StringConstructor;
        default: string;
        validator: (value: string) => boolean;
    };
    icon: {
        type: StringConstructor;
        default: string;
    };
    activeIcon: {
        type: StringConstructor;
        default: string;
    };
    movable: {
        type: BooleanConstructor;
        default: boolean;
    };
    position: {
        type: PropType<PositionProperty>;
        validator: (value: string) => boolean;
    };
    left: StringConstructor;
    top: StringConstructor;
    right: StringConstructor;
    bottom: StringConstructor;
    zIndex: {
        type: PropType<ZIndexProperty>;
        default: number;
    };
    itemClickClose: {
        type: BooleanConstructor;
        default: boolean;
    };
    outsideClose: {
        type: BooleanConstructor;
        default: boolean;
    };
    manual: {
        type: BooleanConstructor;
        default: boolean;
    };
    localKey: StringConstructor;
    sizeOptions: {
        type: ObjectConstructor;
        default: () => {
            large: {
                fab: {
                    size: number;
                    fontSize: string;
                };
                item: {
                    size: number;
                    spacing: number;
                    titleFontSize: string;
                    buttonFontSize: string;
                };
            };
            default: {
                fab: {
                    size: number;
                    fontSize: string;
                };
                item: {
                    size: number;
                    spacing: number;
                    titleFontSize: string;
                    buttonFontSize: string;
                };
            };
            small: {
                fab: {
                    size: number;
                    fontSize: string;
                    padding: number;
                };
                item: {
                    size: number;
                    spacing: number;
                    titleFontSize: string;
                    buttonFontSize: string;
                };
            };
        };
    };
}, {
    close: () => void;
}, unknown, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, ("click" | "close" | "outside-click")[], "click" | "close" | "outside-click", import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{
    modelValue: BooleanConstructor;
    id: StringConstructor;
    type: {
        type: StringConstructor;
        default: string;
    };
    items: any;
    size: {
        type: StringConstructor;
        default: string;
        validator: (value: string) => boolean;
    };
    direction: {
        type: StringConstructor;
        default: string;
        validator: (value: string) => boolean;
    };
    icon: {
        type: StringConstructor;
        default: string;
    };
    activeIcon: {
        type: StringConstructor;
        default: string;
    };
    movable: {
        type: BooleanConstructor;
        default: boolean;
    };
    position: {
        type: PropType<PositionProperty>;
        validator: (value: string) => boolean;
    };
    left: StringConstructor;
    top: StringConstructor;
    right: StringConstructor;
    bottom: StringConstructor;
    zIndex: {
        type: PropType<ZIndexProperty>;
        default: number;
    };
    itemClickClose: {
        type: BooleanConstructor;
        default: boolean;
    };
    outsideClose: {
        type: BooleanConstructor;
        default: boolean;
    };
    manual: {
        type: BooleanConstructor;
        default: boolean;
    };
    localKey: StringConstructor;
    sizeOptions: {
        type: ObjectConstructor;
        default: () => {
            large: {
                fab: {
                    size: number;
                    fontSize: string;
                };
                item: {
                    size: number;
                    spacing: number;
                    titleFontSize: string;
                    buttonFontSize: string;
                };
            };
            default: {
                fab: {
                    size: number;
                    fontSize: string;
                };
                item: {
                    size: number;
                    spacing: number;
                    titleFontSize: string;
                    buttonFontSize: string;
                };
            };
            small: {
                fab: {
                    size: number;
                    fontSize: string;
                    padding: number;
                };
                item: {
                    size: number;
                    spacing: number;
                    titleFontSize: string;
                    buttonFontSize: string;
                };
            };
        };
    };
}>> & {
    onClick?: ((...args: any[]) => any) | undefined;
    onClose?: ((...args: any[]) => any) | undefined;
    "onOutside-click"?: ((...args: any[]) => any) | undefined;
}, {
    type: string;
    icon: string;
    zIndex: ZIndexProperty;
    size: string;
    modelValue: boolean;
    direction: string;
    movable: boolean;
    manual: boolean;
    items: any;
    activeIcon: string;
    itemClickClose: boolean;
    outsideClose: boolean;
    sizeOptions: Record<string, any>;
}>;
export default _default;
