import { StepperOptions, StepOptions } from './types';
export declare class Stepper implements StepperOptions {
    steps: [Step];
    index: number;
    activeSet: any;
    isLoading: boolean;
    onCancelButtonText: string;
    onFinishButtonText: string;
    prevButtonText: string;
    nextButtonText: string;
    buttonSize: string;
    footerAlign: string;
    showCancel: any;
    beforeActive: Function;
    beforeLeave: Function;
    height: string;
    constructor(options?: StepperOptions);
    isFirst(index: number): boolean;
    isLast(index: number): boolean;
    isActive(index: number): boolean;
    isCurrent(index: number): boolean;
    active(index: number): Promise<void>;
    next(): void;
    prev(): void;
    getStep(index: number): Step | undefined;
    executeBeforeLeave(index: number, forward: boolean): any;
    executeBeforeActive(index: number, forward: boolean): any;
}
export declare class Step implements StepOptions {
    id?: string;
    index: number;
    beforeActive?: Function;
    beforeLeave?: Function;
    title?: string;
    description?: string;
    icon?: string;
    status?: string;
    constructor(options?: StepOptions);
}
